create or replace FUNCTION ARQDIGITAL_BLOCOE(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_VALORSTENTR  IN NUMBER) RETURN NUMBER
AS
   V_CONTREGE      NUMBER;
   V_MOVIMENT      NUMBER;
   V_CDIMPOSTRIB   VARCHAR2(02);
   V_VRTOTIMPOSNF  NUMBER;
   V_VRTOTENTR     NUMBER;
   V_VRTOTOUTRCRED NUMBER;
   V_COD_PAR       VARCHAR2(100);
   V_SEQUPROD      NUMBER;
   V_FCP           VARCHAR2(10);
   V_TEMFCP        VARCHAR2(50);
   V_VRRECEITAGUIA NUMBER;
   V_INFCOMPL      VARCHAR2(01);

BEGIN
   V_CONTREGE := 0;
   V_MOVIMENT := 0;

   FOR C_REGE020 IN (SELECT ('|E020'                                                                                                                          || '|' ||
                            N.CAMPO2                                                                                                                         || '|' ||
                            N.CAMPO3                                                                                                                         || '|' ||
                            N.IDORIG                                                                                                                         || '|' ||
                            N.CDMODDOCFISC                                                                                                                   || '|' ||
                            N.IDSTATUS                                                                                                                       || '|' ||
                            N.CDSERIE                                                                                                                        || '|' ||
                            N.NRNOTAFISC                                                                                                                     || '|' ||
                            DTEMISSAO                                                                                                                        || '|' ||
                            N.NRLANCTBDOC                                                                                                                    || '|' ||
                            N.DTENTRSAID                                                                                                                     || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRCONTABILNF,2), '999999999990.00')), '.', ','),'0,00')                                                    || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRBASECALCNF,2), '999999999990.00')), '.', ','),'0,00')                                                    || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRIMPOSTONF,2), '999999999990.00')), '.', ','),'0,00')                                                     || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2), '999999999990.00')), '.', ','),'0,00')    || '|' ||
                            '0,00'                                                                                                                                       || '|' ||
                            '00'                                                                                                                                         || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRISENTRIB,2), '999999999990.00')), '.', ','),'0,00')                                                      || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VROUTRCRED,2), '999999999990.00')), '.', ','),'0,00')                                                      || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '10', 'B', '1'),2), '999999999990.00')), '.', ','),'0,00')        || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '10', 'I', '1'),2), '999999999990.00')), '.', ','),'0,00')        || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '10', 'C', '2'),2), '999999999990.00')), '.', ','),'0,00')        || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '10', 'C', '3'),2), '999999999990.00')), '.', ','),'0,00')        || '|' ) AS ARQ_E020,
                            N.CDFILIAL, N.NRLANCTONF, N.IDORIG, N.IDORIGDESTNF, N.IDENTRSAIDOP
                       FROM (SELECT '1' AS CAMPO2,
                                    '0' AS CAMPO3,
                                    DECODE(N.IDORIGDESTNF, 'F', N.CDFORNECED, DECODE(N.IDORIGDESTNF, 'C', N.CDCLIENTE , DECODE(N.IDENTRSAIDOP, 'E', N.CDFILIEMIT, N.CDFILIRECE))) AS IDORIG,
                                    N.CDMODDOCFISC,
                                    DECODE(N.IDSTATUS, 'C', '02', DECODE(N.IDENTRSAIDOP,'S', (CASE WHEN N.DTEMISSAO < P_DTINICIAL THEN '01' ELSE '00' END), DECODE(N.IDENTRSAIDOP,'E', (CASE WHEN N.DTENTRSAID < P_DTINICIAL THEN '01' ELSE '00' END),'00'))) AS IDSTATUS,
                                    N.CDSERIE, N.IDORIGDESTNF,
                                    N.NRNOTAFISC,
                                    N.CDFILIAL,
                                    N.NRLANCTONF,
                                    TO_CHAR(N.DTEMISSAO,'DDMMYYYY') AS DTEMISSAO,
                                    N.NRLANCTBDOC,
                                    TO_CHAR(N.DTENTRSAID,'DDMMYYYY') AS DTENTRSAID,
                                    SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                    SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                    SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                    SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                    SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                    N.IDENTRSAIDOP
                               FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                              WHERE M.CDEMPRESA         = P_CDEMPRESA
                                AND M.CDINSCESTA        = P_CDINSCESTA
                                AND M.DTINIPERIODO      = P_DTINICIAL
                                AND M.DTFIMPERIODO      = P_DTFINAL
                                AND M.CDIMPOSTO         = P_CDIMPOSTO
                                AND I.NRSEQUMAPAPU      = M.NRSEQUMAPAPU
                                AND I.CDIMPOSTO         = P.CDIMPOSTO
                                AND P.CDIMPOSTONFE      = P_CDIMPOSTO
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL          = I.CDFILIAL
                                AND N.IDENTRSAIDOP      = 'S'
                                AND N.NRLANCTONF        = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND NVL(N.IDSISTEMA,'DFS') <> 'FIS'
                                AND ((N.CDMODDOCFISC = '01') OR (N.CDMODDOCFISC = '04') OR (N.CDMODDOCFISC = '55'))
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0', '1'),
                                    DECODE(N.IDORIGDESTNF, 'F', N.CDFORNECED, DECODE(N.IDORIGDESTNF, 'C', N.CDCLIENTE, DECODE(N.IDENTRSAIDOP, 'E', N.CDFILIEMIT, N.CDFILIRECE))),
                                    N.CDMODDOCFISC,
                                    DECODE(N.IDSTATUS, 'C', '02', DECODE(N.IDENTRSAIDOP,'S', (CASE WHEN N.DTEMISSAO < P_DTINICIAL THEN '01' ELSE '00' END), DECODE(N.IDENTRSAIDOP,'E', (CASE WHEN N.DTENTRSAID < P_DTINICIAL THEN '01' ELSE '00' END),'00'))),
                                    N.CDSERIE, N.NRNOTAFISC, TO_CHAR(N.DTEMISSAO,'DDMMYYYY'),
                                    N.IDORIGDESTNF, N.NRLANCTBDOC, TO_CHAR(N.DTENTRSAID,'DDMMYYYY'), N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP
                              UNION ALL
                             SELECT '0' AS CAMPO2,
                                    '1' AS CAMPO3,
                                    DECODE(N.IDORIGDESTNF, 'F', N.CDFORNECED, DECODE(N.IDORIGDESTNF, 'C', N.CDCLIENTE , DECODE(N.IDENTRSAIDOP, 'E', N.CDFILIEMIT, N.CDFILIRECE))) AS IDORIG,
                                    N.CDMODDOCFISC,
                                    DECODE(N.IDSTATUS, 'C', '02', DECODE(N.IDENTRSAIDOP,'S', (CASE WHEN N.DTEMISSAO < P_DTINICIAL THEN '01' ELSE '00' END), DECODE(N.IDENTRSAIDOP,'E', (CASE WHEN N.DTENTRSAID < P_DTINICIAL THEN '01' ELSE '00' END),'00'))) AS IDSTATUS,
                                    N.CDSERIE, N.IDORIGDESTNF,
                                    N.NRNOTAFISC,
                                    N.CDFILIAL,
                                    N.NRLANCTONF,
                                    TO_CHAR(N.DTEMISSAO,'DDMMYYYY') AS DTEMISSAO,
                                    N.NRLANCTBDOC,
                                    TO_CHAR(N.DTENTRSAID,'DDMMYYYY') AS DTENTRSAID,
                                    SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                    SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                    SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                    SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                    SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                    N.IDENTRSAIDOP
                               FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                              WHERE M.CDEMPRESA         = P_CDEMPRESA
                                AND M.CDINSCESTA        = P_CDINSCESTA
                                AND M.DTINIPERIODO      = P_DTINICIAL
                                AND M.DTFIMPERIODO      = P_DTFINAL
                                AND M.CDIMPOSTO         = P_CDIMPOSTO
                                AND I.NRSEQUMAPAPU      = M.NRSEQUMAPAPU
                                AND I.CDIMPOSTO         = P.CDIMPOSTO
                                AND P.CDIMPOSTONFE      = P_CDIMPOSTO
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.IDENTRSAIDOP      = 'E'
                                AND N.CDFILIAL          = I.CDFILIAL
                                AND N.NRLANCTONF        = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND NVL(N.IDSISTEMA,'DFS') <> 'FIS'
                                AND ((N.CDMODDOCFISC = '01') OR (N.CDMODDOCFISC = '04') OR (N.CDMODDOCFISC = '55'))
                             GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0', '1'),
                                      DECODE(N.IDORIGDESTNF, 'F', N.CDFORNECED, DECODE(N.IDORIGDESTNF, 'C', N.CDCLIENTE, DECODE(N.IDENTRSAIDOP, 'E', N.CDFILIEMIT, N.CDFILIRECE))),
                                      N.IDORIGDESTNF, N.CDMODDOCFISC,
                                      DECODE(N.IDSTATUS, 'C', '02', DECODE(N.IDENTRSAIDOP,'S', (CASE WHEN N.DTEMISSAO < P_DTINICIAL THEN '01' ELSE '00' END), DECODE(N.IDENTRSAIDOP,'E', (CASE WHEN N.DTENTRSAID < P_DTINICIAL THEN '01' ELSE '00' END),'00'))),
                                      N.CDSERIE, N.NRNOTAFISC, TO_CHAR(N.DTEMISSAO,'DDMMYYYY'),
                                      N.NRLANCTBDOC, TO_CHAR(N.DTENTRSAID,'DDMMYYYY'), N.CDFILIAL, N.NRLANCTONF, N.IDENTRSAIDOP)  N ) LOOP

      IF C_REGE020.IDENTRSAIDOP = 'E' THEN
         SELECT DECODE(MAX(IDIMPOSTONF),'3','AAAAAFCP','')
           INTO V_FCP
           FROM IMPOSTONF
          WHERE CDFILIAL    = C_REGE020.CDFILIAL
            AND NRLANCTONF  = C_REGE020.NRLANCTONF
            AND CDIMPOSTO   = P_CDIMPOSTO
            AND IDIMPOSTONF = '3';
      ELSE
         V_FCP := '';
      END IF;

      SELECT MAX(CDCHAVEREG)
        INTO V_COD_PAR
        FROM TMP_LVELETRONICO
       WHERE CDCHAVEREG = C_REGE020.IDORIG
         AND CDREGISTRO = '0150';

      IF (V_COD_PAR IS NULL) AND (C_REGE020.IDORIG IS NOT NULL) THEN
         V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
         INSERT INTO TMP_LVELETRONICO
           (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
         VALUES
           ('0150', V_SEQUPROD, C_REGE020.IDORIG, C_REGE020.IDORIGDESTNF);
      END IF;
      V_COD_PAR := '';

      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('30'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE020.ARQ_E020||V_FCP||'|', P_NRSEQARQMAG);
      V_CONTREGE := NVL(V_CONTREGE,0) + 1;

      FOR C_REGE025 IN (SELECT ('|E025'                                                                          || '|' ||
                               N.CDFISCOPERIT                                                                   || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRCONTABILNF,2)), '999999999990.00')), '.', ','),'0,00')    || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRBASECALCNF,2)), '999999999990.00')), '.', ','),'0,00')    || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRALIQITEM,2), '999999999990.00')), '.', ','),'0,00')        || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSTONF,2)), '999999999990.00')), '.', ','),'0,00')     || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VALOR_IMPOSTO_ITEM_NFE(C_REGE020.CDFILIAL, C_REGE020.NRLANCTONF, N.NRSEQITPROD, '80', 'I', '1'),2)), '999999999990.00')), '.', ','),'0,00')  || '|' ||
                               '0,00'                                                                           || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRISENTRIB,2)), '999999999990.00')), '.', ','),'0,00')      || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VROUTRCRED,2)), '999999999990.00')), '.', ','),'0,00')      || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(DECODE(N.NRITPROIMPOS,'1',VALOR_IMPOSTO_ITEM_NFE(C_REGE020.CDFILIAL, C_REGE020.NRLANCTONF, N.NRSEQITPROD,'10', 'B', '1'),0),2)), '999999999990.00')), '.', ','),'0,00')  || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(DECODE(N.NRITPROIMPOS,'1',VALOR_IMPOSTO_ITEM_NFE(C_REGE020.CDFILIAL, C_REGE020.NRLANCTONF, N.NRSEQITPROD,'10', 'I', '1'),0),2)), '999999999990.00')), '.', ','),'0,00')  || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(DECODE(N.NRITPROIMPOS,'1',VALOR_IMPOSTO_ITEM_NFE(C_REGE020.CDFILIAL, C_REGE020.NRLANCTONF, N.NRSEQITPROD,'10', 'C', '2'),0),2)), '999999999990.00')), '.', ','),'0,00')  || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(DECODE(N.NRITPROIMPOS,'1',VALOR_IMPOSTO_ITEM_NFE(C_REGE020.CDFILIAL, C_REGE020.NRLANCTONF, N.NRSEQITPROD,'10', 'C', '3'),0),2)), '999999999990.00')), '.', ','),'0,00')  || '|'  ) AS ARQ_E025
                          FROM (SELECT I.CDFISCOPERIT,
                                       DECODE(I.CDFISCALIT,'1',I.VRALIQITEM,0) AS VRALIQITEM,
                                       NVL(SUM(ROUND(I.VRCONTITIMP,2)),0) AS VRCONTABILNF,
                                       NVL(SUM(DECODE(I.CDFISCALIT,'1',ROUND(I.VRBASECALCIT,2),0)),0) AS VRBASECALCNF,
                                       NVL(SUM(DECODE(I.CDFISCALIT,'1',ROUND(I.VRIMPOSTOIT, 2),0)),0) AS VRIMPOSTONF,
                                       NVL(SUM(DECODE(I.CDFISCALIT,'3',ROUND(I.VRCONTITIMP, 2),0)),0) AS VROUTRCRED,
                                       NVL(SUM(DECODE(I.CDFISCALIT,'2',ROUND(I.VRCONTITIMP, 2),0)),0) AS VRISENTRIB,
                                       I.NRSEQITPROD, I.NRITPROIMPOS
                                  FROM ITEMPROIMPOS I, IMPOSTO P
                                 WHERE I.CDFILIAL       = C_REGE020.CDFILIAL
                                   AND I.NRLANCTONF     = C_REGE020.NRLANCTONF
                                   AND I.CDIMPOSTO      = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE   = P_CDIMPOSTO
                                   AND NVL(I.NRITPROIMPOS, '1') <> '3'
                                 GROUP BY I.CDFISCOPERIT, DECODE(I.CDFISCALIT,'1',I.VRALIQITEM,0), I.NRSEQITPROD, I.NRITPROIMPOS) N
                         GROUP BY N.CDFISCOPERIT, N.VRALIQITEM) LOOP
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('30'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE025.ARQ_E025, P_NRSEQARQMAG);
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
      END LOOP;
   END LOOP;

   FOR C_REGE050 IN (SELECT ('|E050'                                                                                        || '|' ||
                            NF.CDMODDOCFISC                                                                                || '|' ||
                            NF.CDSERIE                                                                                     || '|' ||
                            ''                                                                                             || '|' ||
                            NF.NUM_INI                                                                                     || '|' ||
                            NF.NUM_FIM                                                                                     || '|' ||
                            TO_CHAR(NF.DTEMISSAO,'DDMMYYYY')                                                               || '|' ||
                            ''                                                                                             || '|' ||
                            ''                                                                                             || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2), '999999999990.00')), '.', ','),'0,00')     || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRBASECALCNF,2), '999999999990.00')), '.', ','),'0,00')     || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRIMPOSTONF,2), '999999999990.00')), '.', ','),'0,00')      || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRISENTAS,2), '999999999990.00')), '.', ','),'0,00')        || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(NF.VROUTRCRED,2), '999999999990.00')), '.', ','),'0,00')       || '|' ||
                            ''                                                                                             || '|'  ) AS ARQ_E050,
                            NF.NRLANCTONF, NF.CDFILIAL, NF.CDCAIXA, NF.CDMODDOCFISC
                       FROM (SELECT I.CDFILIAL, '' AS CDCAIXA, I.NRLANCTONF, N.CDMODDOCFISC, N.CDSERIE, N.NRNOTAFISC AS NUM_INI,
                                    N.DTEMISSAO, N.NRNOTAFISC AS NUM_FIM,
                                    SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                    SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                    SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                    SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                    SUM(DECODE(I.CDFISCALNF,'2',ROUND(VRCONTABILNF,  2),0)) AS VRISENTAS
                               FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                              WHERE M.CDEMPRESA       = P_CDEMPRESA
                                AND M.CDINSCESTA      = P_CDINSCESTA
                                AND M.DTINIPERIODO    = P_DTINICIAL
                                AND M.DTFIMPERIODO    = P_DTFINAL
                                AND M.CDIMPOSTO       = P_CDIMPOSTO
                                AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                AND I.CDIMPOSTO       = P.CDIMPOSTO
                                AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.CDMODDOCFISC    = '02'
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND NVL(N.IDSISTEMA,'DFS') <> 'FIS'
                                AND N.NRLANCTONF      = I.NRLANCTONF
                              GROUP BY I.CDFILIAL, I.NRLANCTONF, N.CDMODDOCFISC, N.CDSERIE,
                                    N.DTEMISSAO, N.NRLANCTBDOC, N.NRNOTAFISC
                              UNION ALL
                             SELECT V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA AS NRLANCTONF, '65' AS CDMODDOCFISC, V.CDSERIENFCE AS CDSERIE,
                                    MIN(V.NRNOTAFISCALCE) AS NUM_INI,
                                    V.DTEMISSAONFCE  AS DTEMISSAO, MAX(V.NRNOTAFISCALCE) AS NUM_FIM,
                                    SUM(TRUNC(I.QTPRODVEND*(I.VRUNITVEND+NVL(I.VRUNITVENDCL,0)),2)-NVL(I.VRDESITVEND,0)+NVL(I.VRACRITVEND,0)) AS VRCONTABILNF,
                                    SUM(CASE WHEN IP.IDTPIMPOSFIS = 'T'
                                             THEN IP.VRBASE
                                             ELSE 0 END) AS VRBASECALCNF,
                                    SUM(CASE WHEN IDTPIMPOSFIS = 'T'
                                             THEN IP.VRIMPOPRODIT
                                             ELSE 0 END) AS VRIMPOSTONF,
                                    SUM(CASE WHEN IP.IDTPIMPOSFIS IN ('F','N')
                                             THEN IP.VRBASE
                                             ELSE 0 END) AS VROUTRCRED,
                                    SUM(CASE WHEN IP.IDTPIMPOSFIS = 'I'
                                             THEN IP.VRBASE
                                             WHEN IP.IDTPIMPOSFIS = 'T'
                                             THEN IP.VRBCREDUZICMS
                                             ELSE 0 END) AS VRISENTAS
                               FROM VENDA V, FILIAL FI, ITEMVENDA I, (SELECT SUM(CASE WHEN I.VRPRBCREDUICMS > 0
                                                                                      THEN I.VRIMPOPRODREDUZ
                                                                                      ELSE TRUNC(I.VRIMPOPRODIT,2) END) AS VRIMPOPRODIT,
                                                                             SUM(CASE WHEN I.VRPRBCREDUICMS > 0
                                                                                      THEN I.VRBASECALCREDUZ
                                                                                      ELSE TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2)-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0) END) AS VRBASE,
                                                                             SUM(CASE WHEN I.VRPRBCREDUICMS > 0
                                                                                      THEN I.VRBCREDUZICMS
                                                                                      ELSE 0 END) AS VRBCREDUZICMS,
                                                                             I.CDFILIAL, I.NRSEQVENDA, I.CDCAIXA, IDTPIMPOSFIS, I.NRSEQUITVEND
                                                                        FROM VENDA V, ITEMVENDA IT, ITVENDAIMPOS I, IMPOSTO IM, FILIAL FI
                                                                       WHERE I.CDIMPOSTO = IM.CDIMPOSTO
                                                                         AND V.IDSTATUSNFCE IN ('A')
                                                                         AND V.IDTPEMISVEND  = 'N'
                                                                         AND V.IDAPROVACAONFCE = 'A'
                                                                         AND TRUNC(V.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL
                                                                         AND V.IDSITUVENDA   = 'O'
                                                                         AND V.IDTPAMBNFCE   = '1'
                                                                         AND IM.IDTPIMPOSFIS IN('T','I','F','N')
                                                                         AND V.CDFILIAL     = IT.CDFILIAL
                                                                         AND V.CDCAIXA      = IT.CDCAIXA
                                                                         AND V.NRSEQVENDA   = IT.NRSEQVENDA
                                                                         AND V.CDFILIAL     = I.CDFILIAL
                                                                         AND V.CDCAIXA      = I.CDCAIXA
                                                                         AND V.NRSEQVENDA   = I.NRSEQVENDA
                                                                         AND IT.CDFILIAL    = I.CDFILIAL
                                                                         AND IT.CDCAIXA     = I.CDCAIXA
                                                                         AND IT.NRSEQVENDA  = I.NRSEQVENDA
                                                                         AND IT.NRSEQUITVEND = I.NRSEQUITVEND
                                                                         AND V.CDFILIAL     = FI.CDFILIAL
                                                                         AND IT.CDFILIAL    = FI.CDFILIAL
                                                                         AND I.CDFILIAL     = FI.CDFILIAL
                                                                         AND FI.CDEMPRESA   = V.CDEMPRESA
                                                                         AND FI.CDINSCESTA  = P_CDINSCESTA
                                                                         AND FI.CDEMPRESA   = P_CDEMPRESA
                                                                       GROUP BY I.CDFILIAL, I.NRSEQVENDA, I.CDCAIXA, IDTPIMPOSFIS, I.NRSEQUITVEND) IP
                              WHERE V.IDSTATUSNFCE IN ('A')
                                AND V.IDTPEMISVEND  = 'N'
                                AND V.IDAPROVACAONFCE = 'A'
                                AND TRUNC(V.DTEMISSAONFCE) BETWEEN P_DTINICIAL AND P_DTFINAL
                                AND V.IDSITUVENDA  = 'O'
                                AND V.IDTPAMBNFCE  = '1'
                                AND FI.CDINSCESTA  = P_CDINSCESTA
                                AND FI.CDEMPRESA   = V.CDEMPRESA
                                AND FI.CDEMPRESA   = P_CDEMPRESA
                                AND I.CDFILIAL     = V.CDFILIAL
                                AND V.CDFILIAL     = FI.CDFILIAL
                                AND I.NRSEQVENDA   = V.NRSEQVENDA
                                AND I.CDCAIXA      = V.CDCAIXA
                                AND I.CDFILIAL     = IP.CDFILIAL(+)
                                AND I.CDCAIXA      = IP.CDCAIXA(+)
                                AND I.NRSEQVENDA   = IP.NRSEQVENDA(+)
                                AND I.NRSEQUITVEND = IP.NRSEQUITVEND(+)
                              GROUP BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, V.CDSERIENFCE, V.DTEMISSAONFCE) NF) LOOP

      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         ('31'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE050.ARQ_E050, P_NRSEQARQMAG);
      V_CONTREGE :=  NVL(V_CONTREGE,0) + 1;

      FOR C_REGE055 IN (SELECT ('|E055'         || '|' ||
                               NF.CDFISCOPERNF || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRCONTABILNF,2), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRBASECALCNF,2), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRALIQNF,2), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRIMPOSTONF,2), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(NF.VRISENTRIB,2), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(NF.VROUTRCRED,2), '999999999990.00')), '.', ','),'0,00') || '|' ) AS ARQ_E055
                          FROM (SELECT I.CDIMPOSTO, I.CDFISCOPERNF,
                                       SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                       DECODE(I.CDFISCALNF,'1',I.VRALIQNF,0) AS VRALIQNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB
                                  FROM IMPOSTONF I, IMPOSTO P
                                 WHERE C_REGE050.CDFILIAL    = I.CDFILIAL
                                   AND C_REGE050.NRLANCTONF  = I.NRLANCTONF
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND I.CDIMPOSTO           = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE        = P_CDIMPOSTO
                                   AND C_REGE050.CDMODDOCFISC <> '65'
                                 GROUP BY I.CDIMPOSTO, I.CDFISCOPERNF, I.VRALIQNF
                                 UNION ALL
                                SELECT IM.CDIMPOSTO, NVL(CDCFOPPROD, '5102') AS CDFISCOPERNF,
                                       SUM(TRUNC((IT.QTPRODVEND  * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2)) AS VRCONTABILNF,
                                       SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T' AND IM.CDIMPOSTONFE = P_CDIMPOSTO
                                                THEN CASE WHEN IP.VRPRBCREDUICMS > 0
                                                          THEN IP.VRBASECALCREDUZ
                                                          ELSE TRUNC(IT.QTPRODVEND*(IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0)),2)-NVL(IT.VRDESITVEND,0)+NVL(IT.VRACRITVEND,0) END
											               ELSE 0 END) AS VRBASECALCNF,
                                       ROUND(IP.VRPEALPRODIT,2) AS VRALIQNF,
                                       SUM(CASE WHEN IM.IDTPIMPOSFIS = 'T' AND IM.CDIMPOSTONFE = P_CDIMPOSTO
									                     THEN CASE WHEN IP.VRPRBCREDUICMS > 0
                                                          THEN IP.VRIMPOPRODREDUZ
                                                          ELSE TRUNC(IP.VRIMPOPRODIT,2) END
                                                ELSE 0 END) AS VRIMPOSTONF,
                                       SUM(CASE WHEN IM.IDTPIMPOSFIS IN ('F','N')
                                                THEN TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2)
                                                ELSE 0 END ) AS VROUTRCRED,
                                       SUM(CASE WHEN IM.IDTPIMPOSFIS = 'I'
                                                THEN TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND+NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2)
											               WHEN IM.IDTPIMPOSFIS = 'T' AND IP.VRPRBCREDUICMS > 0
											               THEN VRBCREDUZICMS
                                                ELSE 0 END) AS VRISENTRIB
                                   FROM ITVENDAIMPOS IP, ITEMVENDA IT, IMPOSTO IM
                                  WHERE IT.CDFILIAL     = IP.CDFILIAL
                                    AND IT.CDCAIXA      = IP.CDCAIXA
                                    AND IT.NRSEQUITVEND = IP.NRSEQUITVEND
                                    AND IT.NRSEQVENDA   = IP.NRSEQVENDA
                                    AND IT.CDFILIAL     = C_REGE050.CDFILIAL
                                    AND IT.CDCAIXA      = C_REGE050.CDCAIXA
                                    AND IT.NRSEQVENDA   = C_REGE050.NRLANCTONF
                                    AND C_REGE050.CDMODDOCFISC = '65'
                                    AND IP.CDIMPOSTO    = IM.CDIMPOSTO
                                  GROUP BY IM.IDTPIMPOSFIS, IM.CDIMPOSTONFE, IM.CDIMPOSTO, NVL(CDCFOPPROD, '5102'), ROUND(IP.VRPEALPRODIT,2) ) NF) LOOP

         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('31'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE055.ARQ_E055, P_NRSEQARQMAG);
         V_CONTREGE :=  NVL(V_CONTREGE,0) + 1;
      END LOOP;
   END LOOP;

   FOR C_FILIAL IN (SELECT CDFILIAL
                      FROM FILIAL
                     WHERE CDINSCESTA = P_CDINSCESTA) LOOP
      FOR C_REGE060 IN (SELECT ('|E060' || '|' ||
                               '2D' || '|' ||
                               R.CDCAIXA|| '|' ||
                               R.NRECFREDZ|| '|' ||
                               R.NRREINIREDZ|| '|' ||
                               R.NRREINIREDZ|| '|' ||
                               TO_CHAR(R.DTREDUCAOZ, 'DDMMYYYY')|| '|' ||
                               R.NRPRIMCFREDZ|| '|' ||
                               R.NRULTCFREDZ|| '|' ||
                               '0,00' || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRGTREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRVENBRUREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                               '0,00' || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRTOTCANREDZ) ,2), '999999999990.00')), '.', ',') || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRTOTCANREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                               '0,00' || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRTOTDESREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRTOTDESREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                               '0,00' || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRTOTACRREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRTOTACRREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                               '0,00' || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRVENLIQREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(I.VRBCALCIMPRZ),2), '999999999990.00')), '.', ',') || '|' ||
                               REPLACE(LTRIM(TO_CHAR(SUM(DECODE(IM.IDTPIMPOSFIS, 'T', TRUNC(I.VRIMPOSTORZ,2), 0)), '999999999990.00')), '.', ',') || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRISENCREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRNINCIDREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                               REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRSTRIBREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                               '' || '|') ARQ_E060, R.CDCAIXA,  R.NRECFREDZ, R.DTREDUCAOZ
                          FROM REDUCAOZ R, IMPOSTOREDZ I, IMPOSTO IM
                         WHERE R.DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL
                           AND R.CDFILIAL = C_FILIAL.CDFILIAL
                           AND R.CDFILIAL = I.CDFILIAL
                           AND R.CDCAIXA = I.CDCAIXA
                           AND R.NRECFREDZ = I.NRECFREDZ
                           AND R.DTREDUCAOZ = I.DTREDUCAOZ
                           AND I.CDIMPOSTO  = IM.CDIMPOSTO
                         GROUP BY R.CDCAIXA,  R.NRECFREDZ, R.NRREINIREDZ, R.NRREINIREDZ, TO_CHAR(R.DTREDUCAOZ, 'DDMMYYYY'),
                               R.NRPRIMCFREDZ, R.NRULTCFREDZ, R.DTREDUCAOZ
                         ORDER BY TO_CHAR(R.DTREDUCAOZ, 'DDMMYYYY')) LOOP

         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('32'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE060.ARQ_E060, P_NRSEQARQMAG);
         V_CONTREGE :=  NVL(V_CONTREGE,0) + 1;

         FOR C_REGE065 IN (SELECT ('|E065'  || '|' ||
                                  '0,00' || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRTOTCANREDZ) ,2), '999999999990.00')), '.', ',') || '|' ||
                                  '0' || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRTOTDESREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                                  '0,00' || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRTOTACRREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                                  '0,00' || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(I.VRBCALCIMPRZ),2), '999999999990.00')), '.', ',') || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(TRUNC(VRALIQIMPRZ,2), '999999999990.00')), '.', ',') || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(SUM(DECODE(IM.IDTPIMPOSFIS, 'T', TRUNC(I.VRIMPOSTORZ,2), 0)), '999999999990.00')), '.', ',') || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRISENCREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(TRUNC(SUM(R.VRNINCIDREDZ),2), '999999999990.00')), '.', ',') || '|' ||
                                  REPLACE(LTRIM(TO_CHAR(SUM(TRUNC(R.VRSTRIBREDZ,2)), '999999999990.00')), '.', ',') || '|' ) ARQ_E065
                             FROM REDUCAOZ R, IMPOSTOREDZ I, IMPOSTO IM
                            WHERE R.DTREDUCAOZ = C_REGE060.DTREDUCAOZ
                              AND R.CDFILIAL = C_FILIAL.CDFILIAL
                              AND R.CDCAIXA = C_REGE060.CDCAIXA
                              AND R.NRECFREDZ = C_REGE060.NRECFREDZ
                              AND R.CDFILIAL = I.CDFILIAL
                              AND R.CDCAIXA = I.CDCAIXA
                              AND R.NRECFREDZ = I.NRECFREDZ
                              AND R.DTREDUCAOZ = I.DTREDUCAOZ
                              AND I.CDIMPOSTO  = IM.CDIMPOSTO
                            GROUP BY REPLACE(LTRIM(TO_CHAR(TRUNC(VRALIQIMPRZ,2), '999999999990.00')), '.', ',')) LOOP

            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('32'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE065.ARQ_E065, P_NRSEQARQMAG);
            V_CONTREGE :=  NVL(V_CONTREGE,0) + 1;
         END LOOP;
      END LOOP;
   END LOOP;

   FOR C_REGE080 IN (SELECT '|E080'          || '|' || -- REGISTRO
                            0                || '|' || -- INDICADOR DO TIPO DE TOTALIZACAO
                            R.NRREDREDZ     || '|' || -- NUMERO DA REDUCAOZ
                            ''              || '|' || -- NUMERO DO LANCAMENTO CONTABIL
                            TO_CHAR(R.DTREDUCAOZ, 'DDMMYYYY') || '|' || -- DATA DA REDUCAOZ
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRVENBRUREDZ,2), '999999999990.00')), '.', ','),'0,00')  || '|' || -- VALOR DA VENDA BRUTA
                            '0,00'                || '|' || -- VALOR DOS CANCELAMENTOS REFERENTES AO ISS
                            '0,00'                || '|' || -- VALOR DOS DESCONTOS REGISTRADOS NAS OPERAES SUJEITAS AO ICMS
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRTOTCANREDZ,2), '999999999990.00')), '.', ','),'0,00')  || '|' || -- VALOR TOTAL DE CANCELAMENTOS
                            '0,00'                || '|' || -- VALOR DOS DESCONTOS REGISTRADOS NAS OPERAES SUJEITAS AO ISS
                            '0,00'                || '|' || -- VALOR DOS DESCONTOS REGISTRADOS NAS OPERAES SUJEITAS AO ICMS
                            '0,00'                || '|' || -- VALOR DOS DESCONTOS REGISTRADOS
                            '0,00'                || '|' || -- VALOR DOS ACRSCIMOS REFERENTES AO ISS
                            '0,00'                || '|' || -- VALOR DOS ACRSCIMOS REFERENTES AO ICMS
                            '0,00'                || '|' || -- VALOR DOS ACRSCIMOS REGISTRADOS
                            '0,00'                || '|' || -- VALOR DOS SERVIOS TRIBUTADOS PELO ISS
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRVENLIQREDZ,2), '999999999990.00')), '.', ','),'0,00')  || '|' || -- VALOR DA VENDA LQUIDA (VALOR CONTBIL)
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRBCALCIMPRZ,2), '999999999990.00')), '.', ','),'0,00')  || '|' || -- VALOR DA BASE DE CLCULO DO ICMS CONSTANTE NO MAPA RESUMO
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRIMPOSTORZ,2), '999999999990.00')), '.', ','),'0,00')   || '|' || -- VALOR DO ICMS DEBITADO CONSTANTE NO MAPA RESUMO
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRISENCREDZ,2), '999999999990.00')), '.', ','),'0,00')   || '|' || -- VALOR DAS SADAS ISENTAS DO ICMS
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRNINCIDREDZ,2), '999999999990.00')), '.', ','),'0,00')  || '|' || -- VALOR DAS SADAS SOB NO-INCIDNCIA OU NO-TRIBUTADAS PELO ICMS
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRSTRIBREDZ,2), '999999999990.00')), '.', ','),'0,00')    || '|' || -- VALOR DAS SADAS DE MERCADORIAS ADQUIRIDAS COM SUBSTITUIO TRIBUTRIA
                            '0'  || '|'/*INDICADOR DE OBSERVAES DO MAPA-RESUMO ECF*/  AS ARQ_E080, R.CDFILIAL, R.DTREDUCAOZ, R.NRREDREDZ
                       FROM (SELECT SUM(VRVENBRUREDZ) AS VRVENBRUREDZ,
                                    SUM(VRTOTCANREDZ) AS VRTOTCANREDZ,
                                    SUM(VRVENLIQREDZ) AS VRVENLIQREDZ,
                                    TRUNC(SUM(VRBCALCIMPRZ),2) AS VRBCALCIMPRZ,
                                    TRUNC(SUM(VRIMPOSTORZ),2) AS VRIMPOSTORZ,
                                    SUM(VRISENCREDZ)  AS VRISENCREDZ,
                                    SUM(VRNINCIDREDZ) AS VRNINCIDREDZ,
                                    SUM(VRSTRIBREDZ)  AS VRSTRIBREDZ,
                                    Z.NRREDREDZ, R.DTREDUCAOZ, FI.CDFILIAL
                               FROM IMPOSTOREDZ R, IMPOSTO I, FILIAL FI, REDUCAOZ Z
                              WHERE R.CDIMPOSTO    = I.CDIMPOSTO
                                AND IDTPIMPOSFIS   = 'T'
                                AND FI.CDEMPRESA   = P_CDEMPRESA
                                AND FI.CDINSCESTA  = P_CDINSCESTA
                                AND FI.CDFILIAL    = R.CDFILIAL
                                AND Z.CDCAIXA      = R.CDCAIXA
                                AND Z.NRECFREDZ    = R.NRECFREDZ
                                AND Z.DTREDUCAOZ   = R.DTREDUCAOZ
                                AND Z.CDFILIAL     = R.CDFILIAL
                                AND I.CDIMPOSTONFE = P_CDIMPOSTO
                                AND Z.DTREDUCAOZ   BETWEEN P_DTINICIAL AND P_DTFINAL
                              GROUP BY Z.NRREDREDZ, R.DTREDUCAOZ, FI.CDFILIAL,
                                      TO_CHAR(R.DTREDUCAOZ,'DDMMYYYY'))R) LOOP
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         ('33'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE080.ARQ_E080, P_NRSEQARQMAG);
      V_CONTREGE := NVL(V_CONTREGE,0) + 1;

      FOR C_REGE085 IN (SELECT ('|E085' || '|' ||
                               0        || '|' || -- VL_CANC_ISS_P
                               0        || '|' || -- VL_CANC_ICMS_P
                               0        || '|' || -- VL_DESC_ISS_P
                               0        || '|' || -- VL_DESC_ICMS_P
                               0        || '|' || -- VL_ACMO_ISS_P
                               0        || '|' || -- VL_ACMO_ICMS_P
                               0        || '|' || -- VL_ISS_P
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRVENDALIQ,2),   '999999999990.00')), '.', ','),'0,00')  || '|' ||  -- VL_CONT_P
                               CFOP     || '|' || -- CFOP
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRBCALCIMPRZ,2), '999999999990.00')), '.', ','),'0,00')  || '|' ||  -- VL_BC_ICMS_P
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRALIQIMPRZ,2),  '999999999990.00')), '.', ','),'0,00')  || '|' ||  -- ALIQ_ICMS
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRIMPOSTORZ,2),  '999999999990.00')), '.', ','),'0,00')  || '|' ||  -- VL_ICMS_P
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRISENCREDZ,2),  '999999999990.00')), '.', ','),'0,00')  || '|' ||  -- VL_ISEN_P
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRNINCIDREDZ,2), '999999999990.00')), '.', ','),'0,00')  || '|' ||  -- VL_NT_P
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(R.VRSTRIBREDZ,2),  '999999999990.00')), '.', ','),'0,00')  || '|'   ) AS ARQ_E085 -- VL_ST_P
                          FROM (SELECT TRUNC(SUM(I.VRBCALCIMPRZ),2) AS VRBCALCIMPRZ,
                                       TRUNC(SUM(I.VRIMPOSTORZ),2) AS VRIMPOSTORZ,
                                       SUM(Z.VRISENCREDZ)  AS VRISENCREDZ,
                                       SUM(Z.VRNINCIDREDZ) AS VRNINCIDREDZ,
                                       0 AS VRSTRIBREDZ,
                                       I.VRALIQIMPRZ,
                                       '5102' AS CFOP,
                                       SUM(NVL(I.VRBCALCIMPRZ,0)+NVL(Z.VRISENCREDZ,0)+NVL(Z.VRNINCIDREDZ,0)) AS VRVENDALIQ
                                  FROM FILIAL FI, REDUCAOZ Z,(SELECT R.VRIMPOSTORZ, R.VRBCALCIMPRZ,
                                                                     I.CDIMPOSTO, R.CDCAIXA, R.VRALIQIMPRZ,
                                                                     R.NRECFREDZ, R.DTREDUCAOZ, R.CDFILIAL
                                                                FROM IMPOSTO I, IMPOSTOREDZ R
                                                               WHERE I.CDIMPOSTONFE = P_CDIMPOSTO
                                                                 AND I.CDIMPOSTO = R.CDIMPOSTO
                                                                 AND I.IDTPIMPOSFIS = 'T'
                                                                 AND R.DTREDUCAOZ = C_REGE080.DTREDUCAOZ
                                                                 AND R.CDFILIAL   = C_REGE080.CDFILIAL) I
                                 WHERE FI.CDEMPRESA    = P_CDEMPRESA
                                   AND FI.CDINSCESTA   = P_CDINSCESTA
                                   AND FI.CDFILIAL     = Z.CDFILIAL
                                   AND Z.CDCAIXA       = I.CDCAIXA(+)
                                   AND Z.NRECFREDZ     = I.NRECFREDZ(+)
                                   AND Z.DTREDUCAOZ    = I.DTREDUCAOZ(+)
                                   AND Z.CDFILIAL      = I.CDFILIAL(+)
                                   AND Z.DTREDUCAOZ    = C_REGE080.DTREDUCAOZ
                                   AND Z.CDFILIAL      = C_REGE080.CDFILIAL
                                   AND Z.NRREDREDZ     = C_REGE080.NRREDREDZ
                                 GROUP BY I.VRALIQIMPRZ
                                 UNION ALL
                                SELECT 0 AS VRBCALCIMPRZ,
                                       0 AS VRIMPOSTORZ,
                                       0 AS VRISENCREDZ,
                                       0 AS VRNINCIDREDZ,
                                       SUM(Z.VRSTRIBREDZ)  AS VRSTRIBREDZ,
                                       0 AS VRALIQIMPRZ,
                                       '5405' AS CFOP,
                                       SUM(Z.VRSTRIBREDZ) AS VRVENDALIQ
                                  FROM FILIAL FI, REDUCAOZ Z
                                 WHERE FI.CDEMPRESA   = P_CDEMPRESA
                                   AND FI.CDINSCESTA  = P_CDINSCESTA
                                   AND FI.CDFILIAL    = Z.CDFILIAL
                                   AND Z.DTREDUCAOZ   = C_REGE080.DTREDUCAOZ
                                   AND Z.CDFILIAL     = C_REGE080.CDFILIAL
                                   AND Z.NRREDREDZ    = C_REGE080.NRREDREDZ
                                   AND Z.VRSTRIBREDZ > 0
                                 GROUP BY '5405')R) LOOP
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         ('33'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE085.ARQ_E085, P_NRSEQARQMAG);
      V_CONTREGE := NVL(V_CONTREGE,0) + 1;
      END LOOP;
   END LOOP;

   FOR C_REGE100 IN (SELECT ('|E100'                   || '|' ||
                            N.IDENTRSAIDOP             || '|' ||
                            '1'                        || '|' ||
                            N.IDORIG                   || '|' ||
                            N.CDMODDOCFISC             || '|' ||
                            N.IDSTATUS                 || '|' ||
                            N.CDSERIE                  || '|' ||
                            ''                         || '|' ||
                            '99'                       || '|' ||
                            N.NRNOTAFISC               || '|' ||
                            N.DTEMISSAO                || '|' ||
                            N.NRLANCTBDOC              || '|' ||
                            DTENTRSAID                 || '|' ||
                            '1'                        || '|' ||
                            CANC.QTNFCANCEL            || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRCONTABILNF,2), '999999999990.00')), '.', ','),'0,00')  || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRBASECALCNF,2), '999999999990.00')), '.', ','),'0,00')  || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRIMPOSTONF,2), '999999999990.00')), '.', ','),'0,00')   || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRISENTRIB,2), '999999999990.00')), '.', ','),'0,00')    || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VROUTRCRED,2), '999999999990.00')), '.', ','),'0,00')    || '|' ||
                            ''                                                                                         || '|'  ) AS ARQ_E100,
                            N.CDFILIAL, N.NRLANCTONF, N.IDORIG , N.IDORIGDESTNF
                       FROM (SELECT N.CDFILIAL, N.NRLANCTONF,
                                    DECODE(N.IDENTRSAIDOP, 'E', '0', '1')  AS IDENTRSAIDOP,
                                    DECODE(N.IDORIGDESTNF, 'F', N.CDFORNECED, DECODE(N.IDORIGDESTNF, 'C', N.CDCLIENTE , DECODE(N.IDENTRSAIDOP, 'E', N.CDFILIEMIT, N.CDFILIRECE))) AS IDORIG,
                                    N.CDMODDOCFISC,
                                    DECODE(N.IDSTATUS, 'C', '02', '00') AS IDSTATUS,
                                    NVL(N.CDSERIE, N.CDSERIEENTR) AS CDSERIE,
                                    N.NRNOTAFISC,
                                    TO_CHAR(N.DTEMISSAO,'DDMMYYYY') AS DTEMISSAO,
                                    N.NRLANCTBDOC,
                                    TO_CHAR(N.DTENTRSAID,'DDMMYYYY') AS DTENTRSAID,
                                    SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                    SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                    SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                    SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                    SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED, N.IDORIGDESTNF
                               FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                              WHERE M.CDEMPRESA       = P_CDEMPRESA
                                AND M.CDINSCESTA      = P_CDINSCESTA
                                AND M.DTINIPERIODO    = P_DTINICIAL
                                AND M.DTFIMPERIODO    = P_DTFINAL
                                AND M.CDIMPOSTO       = P_CDIMPOSTO
                                AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                AND I.CDIMPOSTO       = P.CDIMPOSTO
                                AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND NVL(N.IDSISTEMA,'DFS')  <> 'FIS'
                                AND N.CDMODDOCFISC      IN ('06','21','22','27','28')
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0', '1'),
                                    DECODE(N.IDORIGDESTNF, 'F', N.CDFORNECED, DECODE(N.IDORIGDESTNF, 'C', N.CDCLIENTE, DECODE(N.IDENTRSAIDOP, 'E', N.CDFILIEMIT, N.CDFILIRECE))),
                                    N.CDMODDOCFISC, DECODE(N.IDSTATUS, 'C', '02', '00'), NVL(N.CDSERIE, N.CDSERIEENTR), N.NRNOTAFISC, TO_CHAR(N.DTEMISSAO,'DDMMYYYY'),
                                    N.IDORIGDESTNF, N.NRLANCTBDOC, TO_CHAR(N.DTENTRSAID,'DDMMYYYY'), N.CDFILIAL, N.NRLANCTONF, N.CDFILIAL, N.NRLANCTONF) N,
                            (SELECT COUNT(*) AS QTNFCANCEL
                               FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                             WHERE M.CDEMPRESA       = P_CDEMPRESA
                               AND M.CDINSCESTA      = P_CDINSCESTA
                               AND M.DTINIPERIODO    = P_DTINICIAL
                               AND M.DTFIMPERIODO    = P_DTFINAL
                               AND M.CDIMPOSTO       = P_CDIMPOSTO
                               AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                               AND I.CDIMPOSTO       = P.CDIMPOSTO
                               AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                               AND NVL(I.IDIMPOSTONF, '1') <> '3'
                               AND N.CDFILIAL        = I.CDFILIAL
                               AND N.NRLANCTONF      = I.NRLANCTONF
                               AND N.IDSTATUS        = 'C'
                               AND NVL(N.IDSISTEMA,'DFS')  <> 'FIS'
                               AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                               AND N.CDMODDOCFISC IN ('06','21','22','27','28')) CANC) LOOP

      SELECT MAX(CDCHAVEREG)
        INTO V_COD_PAR
        FROM TMP_LVELETRONICO
       WHERE CDCHAVEREG = C_REGE100.IDORIG
         AND CDREGISTRO = '0150';

      IF (V_COD_PAR IS NULL) AND (C_REGE100.IDORIG IS NOT NULL) THEN
         V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
         INSERT INTO TMP_LVELETRONICO
           (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
         VALUES
           ('0150', V_SEQUPROD, C_REGE100.IDORIG, C_REGE100.IDORIGDESTNF);
      END IF;

      V_COD_PAR := '';
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('34'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE100.ARQ_E100, P_NRSEQARQMAG);
      V_CONTREGE := NVL(V_CONTREGE,0) + 1;

      FOR C_REGE105 IN (SELECT ('|E105'                                                                          || '|' ||
                               N.CDFISCOPERNF                                                                   || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRCONTABILNF,2), '999999999990.00')), '.', ','),'0,00')    || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRBASECALCNF,2), '999999999990.00')), '.', ','),'0,00')    || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRALIQNF,2), '999999999990.00')), '.', ','),'0,00')        || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRIMPOSTONF,2), '999999999990.00')), '.', ','),'0,00')     || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRISENTRIB,2), '999999999990.00')), '.', ','),'0,00')      || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VROUTRCRED,2), '999999999990.00')), '.', ','),'0,00')      || '|'  ) AS ARQ_E105
                          FROM (SELECT I.CDFISCOPERNF,
                                       I.VRALIQNF,
                                       NVL(SUM(ROUND(I.VRCONTABILNF,2)),0) AS VRCONTABILNF,
                                       NVL(SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)),0) AS VRBASECALCNF,
                                       NVL(SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)),0) AS VRIMPOSTONF,
                                       NVL(SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)),0) AS VROUTRCRED,
                                       NVL(SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)),0) AS VRISENTRIB
                                  FROM IMPOSTONF I, IMPOSTO P
                                 WHERE I.CDFILIAL       = C_REGE100.CDFILIAL
                                   AND I.NRLANCTONF     = C_REGE100.NRLANCTONF
                                   AND I.NRSEQUMAPAPU   IS NOT NULL
                                   AND I.CDIMPOSTO      = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE   = P_CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                 GROUP BY I.CDFISCOPERNF, I.VRALIQNF) N) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('34'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE105.ARQ_E105, P_NRSEQARQMAG);
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
      END LOOP;
   END LOOP;

   FOR C_REGE120 IN (SELECT ('|E120'                   || '|' ||
                            N.IDENTRSAIDOP             || '|' ||
                            '0'                        || '|' ||
                            N.IDORIG                   || '|' ||
                            N.CDMODDOCFISC             || '|' ||
                            N.IDSTATUS                 || '|' ||
                            N.CDSERIE                  || '|' ||
                            ''                         || '|' ||
                            N.NRNOTAFISC               || '|' ||
                            N.DTEMISSAO                || '|' ||
                            N.NRLANCTBDOC              || '|' ||
                            N.DTENTRSAID               || '|' ||
                            N.CDFISCOPERNF             || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRCONTABILNF,2), '999999999990.00')), '.', ','),'0,00')  || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRBASECALCNF,2), '999999999990.00')), '.', ','),'0,00')  || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRALIQNF,2), '999999999990.00')), '.', ','),'0,00')  || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRIMPOSTONF,2), '999999999990.00')), '.', ','),'0,00')   || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VRISENTRIB,2), '999999999990.00')), '.', ','),'0,00')    || '|' ||
                            NVL(REPLACE(LTRIM(TO_CHAR(ROUND(N.VROUTRCRED,2), '999999999990.00')), '.', ','),'0,00')    || '|' ||
                            ''                                                                                         || '|'  ) AS ARQ_E120,
                            N.CDFILIAL, N.NRLANCTONF, N.IDORIG, N.IDORIGDESTNF
                       FROM (SELECT N.CDFILIAL, N.NRLANCTONF,
                                    DECODE(N.IDENTRSAIDOP, 'E', '0', '1')  AS IDENTRSAIDOP,
                                    DECODE(N.IDORIGDESTNF, 'F', N.CDFORNECED, DECODE(N.IDORIGDESTNF, 'C', N.CDCLIENTE , DECODE(N.IDENTRSAIDOP, 'E', N.CDFILIEMIT, N.CDFILIRECE))) AS IDORIG,
                                    N.CDMODDOCFISC, IDORIGDESTNF,
                                    DECODE(N.IDSTATUS, 'C', '02', '00') AS IDSTATUS,
                                    NVL(N.CDSERIE, N.CDSERIEENTR) AS CDSERIE,
                                    N.NRNOTAFISC, I.CDFISCOPERNF,
                                    TO_CHAR(N.DTEMISSAO,'DDMMYYYY') AS DTEMISSAO,
                                    N.NRLANCTBDOC,
                                    TO_CHAR(N.DTENTRSAID,'DDMMYYYY') AS DTENTRSAID,
                                    SUM(ROUND(I.VRALIQNF,2)) AS VRALIQNF,
                                    SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                    SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                    SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                    SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                    SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED
                               FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                              WHERE M.CDEMPRESA       = P_CDEMPRESA
                                AND M.CDINSCESTA      = P_CDINSCESTA
                                AND M.DTINIPERIODO    = P_DTINICIAL
                                AND M.DTFIMPERIODO    = P_DTFINAL
                                AND M.CDIMPOSTO       = P_CDIMPOSTO
                                AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                AND I.CDIMPOSTO       = P.CDIMPOSTO
                                AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                AND N.CDFILIAL        = I.CDFILIAL
                                AND N.NRLANCTONF      = I.NRLANCTONF
                                AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                AND NVL(N.IDSISTEMA,'DFS')  <> 'FIS'
                                AND N.CDMODDOCFISC IN ('07','08','09','10','11','26','18')
                              GROUP BY DECODE(N.IDENTRSAIDOP, 'E', '0', '1'),
                                    DECODE(N.IDORIGDESTNF, 'F', N.CDFORNECED, DECODE(N.IDORIGDESTNF, 'C', N.CDCLIENTE, DECODE(N.IDENTRSAIDOP, 'E', N.CDFILIEMIT, N.CDFILIRECE))),
                                    DECODE(N.IDSTATUS, 'C', '02', '00'), NVL(N.CDSERIE, N.CDSERIEENTR), N.NRNOTAFISC, TO_CHAR(N.DTEMISSAO,'DDMMYYYY'),
                                    N.IDORIGDESTNF, N.NRLANCTBDOC, TO_CHAR(N.DTENTRSAID,'DDMMYYYY'), N.CDFILIAL, N.NRLANCTONF,
                                    N.CDFILIAL, N.NRLANCTONF, I.CDFISCOPERNF, N.CDMODDOCFISC) N) LOOP
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         ('35'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE120.ARQ_E120, P_NRSEQARQMAG);
      V_CONTREGE := NVL(V_CONTREGE,0) + 1;

      SELECT MAX(CDCHAVEREG)
        INTO V_COD_PAR
        FROM TMP_LVELETRONICO
       WHERE CDCHAVEREG = C_REGE120.IDORIG
         AND CDREGISTRO = '0150';

      IF (V_COD_PAR IS NULL) AND (C_REGE120.IDORIG IS NOT NULL) THEN
         V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
         INSERT INTO TMP_LVELETRONICO
            (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1)
         VALUES
            ('0150', V_SEQUPROD, C_REGE120.IDORIG, C_REGE120.IDORIGDESTNF);
      END IF;
      V_COD_PAR := '';
   END LOOP;

   FOR C_REGE300 IN (SELECT ('|E300'                            || '|' ||
                            TO_CHAR(DTINIPERIODO,'DDMMYYYY')    || '|' ||
                            TO_CHAR(DTFIMPERIODO,'DDMMYYYY')    || '|'  ) AS ARQ_E300,
                            TO_CHAR(DTINIPERIODO,'DDMMYYYY') AS DTINICIAL,
                            TO_CHAR(DTFIMPERIODO,'DDMMYYYY') AS DTFINAL
                       FROM MAPAAPURAC
                      WHERE CDEMPRESA     = P_CDEMPRESA
                        AND CDINSCESTA    = P_CDINSCESTA
                        AND DTINIPERIODO  = P_DTINICIAL
                        AND DTFIMPERIODO  = P_DTFINAL
                        AND CDIMPOSTO     = P_CDIMPOSTO) LOOP

      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         ('36'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE300.ARQ_E300, P_NRSEQARQMAG);
      V_CONTREGE := NVL(V_CONTREGE,0) + 1;

      FOR C_REGE310 IN (SELECT ('|E310'                                                                                    || '|' ||
                               N.CDFISCOPERNF                                                                             || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(N.VRCONTABILNF),2),0), '999999999990.00')), '.', ',')  || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(N.VRBASECALCNF),2),0), '999999999990.00')), '.', ',')  || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(N.VRIMPOSTONF), 2),0), '999999999990.00')), '.', ',')  || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(N.VRIMPOSUB),   2),0), '999999999990.00')), '.', ',')  || '|' ||
                               '0'                                                                                        || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(N.VRISENTRIB),  2),0), '999999999990.00')), '.', ',')  || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(SUM(DECODE(TP_NF,'N',N.VROUTRCRED,0)),  2),0), '999999999990.00')), '.', ',')  || '|'  ) AS ARQ_E310,
                               C_REGE300.DTINICIAL
                          FROM (SELECT T.CDFISCOPERIT AS CDFISCOPERNF, 
                                       SUM(ROUND(T.VRCONTITIMP,2)) AS VRCONTABILNF, 
                                       SUM(DECODE(T.CDFISCALIT,'1',ROUND(T.VRBASECALCIT,2),0)) AS VRBASECALCNF, 
                                       SUM(DECODE(T.CDFISCALIT,'1',ROUND(T.VRIMPOSTOIT,2) ,0)) AS VRIMPOSTONF, 
                                       SUM(DECODE(T.CDFISCALIT,'3',ROUND(T.VRCONTITIMP,2) ,0)) AS VROUTRCRED, 
                                       SUM(DECODE(T.CDFISCALIT,'2',ROUND(T.VRCONTITIMP,2) ,0)) AS VRISENTRIB, 
                                       SUM(ROUND(VALOR_IMPOSTO_ITEM_NFE(T.CDFILIAL, T.NRLANCTONF, T.NRSEQITPROD,'80','I','1'),2)) AS VRIMPOSUB,
                                       'N' AS TP_NF, N.CDFILIAL, N.NRLANCTONF
                                  FROM NOTAFISCAL N, IMPOSTO P, ITEMPROIMPOS T,
                                       (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
                                         FROM MAPAAPURAC M, IMPOSTONF I
                                        WHERE M.CDEMPRESA       = P_CDEMPRESA
                                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU) I
                                 WHERE I.CDFILIAL        = T.CDFILIAL
                                   AND I.NRLANCTONF      = T.NRLANCTONF
                                   AND T.CDIMPOSTO       = P.CDIMPOSTO 
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO 
                                   AND NVL(T.NRITPROIMPOS, '1') <> '3' 
                                   AND N.CDFILIAL        = I.CDFILIAL 
                                   AND N.NRLANCTONF      = I.NRLANCTONF 
                                   AND N.IDENTRSAIDOP    = 'E' 
                                   AND N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55') 
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) 
                                 GROUP BY T.CDFISCOPERIT, N.CDFILIAL, N.NRLANCTONF
                                 UNION ALL
                                SELECT I.CDFISCOPERNF,
                                       SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                       ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2) AS VRIMPOSUB,
                                       'N' AS TP_NF, N.CDFILIAL, N.NRLANCTONF
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND NVL(N.IDSISTEMA,'DFS')  <> 'FIS'
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55')
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                 GROUP BY I.CDFISCOPERNF, ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2),
                                       N.CDFILIAL, N.NRLANCTONF
                                 UNION ALL
                                SELECT I.CDFISCOPERNF,
                                       SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                       SUM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2)) AS VRIMPOSUB,
                                       MAX(NVL((SELECT MAX('E')
                                                  FROM MOVCAIXA M, VENDA V
                                                 WHERE M.CDFILIAL   = V.CDFILIAL
                                                   AND M.CDCAIXA    = V.CDCAIXA
                                                   AND M.NRSEQVENDA = V.NRSEQVENDA
                                                   AND NVL(V.IDTPEMISVEND,'E') = 'E'
                                                   AND M.CDFILIALNFFIS = I.CDFILIAL
                                                   AND M.NRLANCTONFFIS = I.NRLANCTONF
                                                   AND M.CDFILIAL = N.CDFILIEMIT),'N')) AS TP_NF,
                                       N.CDFILIAL, N.NRLANCTONF
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
								           AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND NVL(N.IDSISTEMA,'DFS') = 'FIS'
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                 GROUP BY I.CDFISCOPERNF, N.CDFILIAL, N.NRLANCTONF)N
                         GROUP BY C_REGE300.DTINICIAL, N.CDFISCOPERNF
                         ORDER BY N.CDFISCOPERNF) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('37'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE310.ARQ_E310, P_NRSEQARQMAG);
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
      END LOOP;
      FOR C_REGE320 IN (SELECT ('|E320'                                                                                || '|' ||
                               DECODE(NF.IDENTRSAIDOP, 'E', '0', '1')                                                 || '|' ||
                               SUBSTR(NF.SGESTADO,1,2)                                                                || '|' ||
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NF.VRCONTABILNF),2), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NF.VRBASECALCNF),2), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NF.VRIMPOSTONF),2), '999999999990.00')), '.', ',')     || '|' ||
                               0     || '|' ||
                               0     || '|' ||
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NF.VRISENTRIB),2), '999999999990.00')), '.', ',')      || '|' ||
                               REPLACE(LTRIM(TO_CHAR(ROUND(SUM(NF.VROUTRCRED),2), '999999999990.00')), '.', ',')      || '|'  ) AS ARQ_E320
                          FROM (SELECT SGESTADO,
                                       IDENTRSAIDOP,
                                       SUM(ROUND(VRCONTABILNF,2))  AS VRCONTABILNF,
                                       SUM(ROUND(VRBASECALCNF,2))  AS VRBASECALCNF,
                                       SUM(ROUND(VRIMPOSTONF,2))   AS VRIMPOSTONF,
                                       SUM(ROUND(VROUTRCRED,2))    AS VROUTRCRED,
                                       SUM(ROUND(VRISENTRIB,2))    AS VRISENTRIB
                                  FROM (SELECT MP.CDEMPRESA, MP.CDINSCESTA, NF.IDENTRSAIDOP,
                                               MIN(MP.DTINIPERIODO) AS DTINIPERIODO,
                                               MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO,
                                               SUM(A.VRCONTABILNF)  AS VRCONTABILNF,
                                               SUM(A.VRBASECALCNF)  AS VRBASECALCNF,
                                               SUM(A.VRIMPOSTONF)   AS VRIMPOSTONF,
                                               SUM(A.VROUTRCRED)    AS VROUTRCRED,
                                               SUM(A.VRISENTRIB)    AS VRISENTRIB,
                                               EP.NMRAZSOCEMPR, IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                               SUBSTR((ET.CDPAIS  ||ETL.CDPAIS  ||ETC.CDPAIS)  ,1,12) AS CDPAIS,
                                               SUBSTR((ET.SGESTADO||ETL.SGESTADO||ETC.SGESTADO),1,6)  AS SGESTADO,
                                               SUBSTR((ET.NMESTADO||ETL.NMESTADO||ETC.NMESTADO),1,90) AS NMESTADO
                                          FROM MAPAAPURAC MP, NOTAFISCAL NF, ENDEFORN EF,
                                               EMPRESA EP, INSCRESTAD IE, ESTADO ET,
                                               ENDECLIE EC, ENDEFILI EL,  ESTADO ETL, ESTADO ETC,
                                               (SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                       SUM(ROUND(VRCONTABILNF,2)) AS VRCONTABILNF,
                                                       SUM(ROUND(VRBASECALCNF,2)) AS VRBASECALCNF,
                                                       SUM(ROUND(VRIMPOSTONF,2))  AS VRIMPOSTONF,
                                                       SUM(ROUND(VROUTRCRED,2))   AS VROUTRCRED,
                                                       SUM(ROUND(VRISENTRIB,2))   AS VRISENTRIB
                                                  FROM (SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                               VRCONTABILNF, VRBASECALCNF, VRIMPOSTONF,
                                                               0 AS VROUTRCRED, 0 AS VRISENTRIB
                                                          FROM IMPOSTONF I, IMPOSTO P
                                                         WHERE CDFISCALNF     = '1'
                                                           AND I.CDIMPOSTO    = P.CDIMPOSTO
                                                           AND P.CDIMPOSTONFE = P_CDIMPOSTO
                                                           AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                         UNION
                                                        SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                               VRCONTABILNF, 0 AS VRBASECALCNF,
                                                               0 AS VRIMPOSTONF, 0 AS VROUTRCRED,
                                                               VRCONTABILNF AS VRISENTRIB
                                                          FROM IMPOSTONF I, IMPOSTO P
                                                         WHERE CDFISCALNF     = '2'
                                                           AND I.CDIMPOSTO    = P.CDIMPOSTO
                                                           AND P.CDIMPOSTONFE = P_CDIMPOSTO
                                                           AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                         UNION
                                                        SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                               VRCONTABILNF, 0 AS VRBASECALCNF,
                                                               0 AS VRIMPOSTONF, VRCONTABILNF AS VROUTRCRED,
                                                               0 AS VRISENTRIB
                                                          FROM IMPOSTONF I, IMPOSTO P
                                                         WHERE CDFISCALNF     = '3'
                                                           AND I.CDIMPOSTO    = P.CDIMPOSTO
                                                           AND P.CDIMPOSTONFE = P_CDIMPOSTO
                                                           AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                         UNION
                                                        SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                               0 AS VRCONTABILNF,
                                                               0 AS VRBASECALCNF, 0 AS VRIMPOSTONF,
                                                               VRIMPOSTONF AS VROUTRCRED,   0 AS VRISENTRIB
                                                          FROM IMPOSTONF I, IMPOSTO P
                                                         WHERE I.CDIMPOSTO   <> P.CDIMPOSTO
                                                           AND P.CDIMPOSTONFE = P_CDIMPOSTO
                                                           AND IDIMPOSTONF    = '4')
                                                 GROUP BY NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF) A
                                         WHERE MP.CDEMPRESA       = P_CDEMPRESA
                                           AND MP.CDINSCESTA      = P_CDINSCESTA
                                           AND MP.CDIMPOSTO       = P_CDIMPOSTO
                                           AND MP.DTINIPERIODO   >= P_DTINICIAL
                                           AND MP.DTFIMPERIODO   <= P_DTFINAL
                                           AND MP.NRSEQUMAPAPU    = A.NRSEQUMAPAPU
                                           AND A.CDFILIAL         = NF.CDFILIAL
                                           AND A.NRLANCTONF       = NF.NRLANCTONF
                                           AND EF.CDFORNECED(+)   = NF.CDFORNECED
                                           AND EC.CDCLIENTE(+)    = NF.CDCLIENTE
                                           AND EL.CDFILIAL(+)     = NF.CDFILIRECE
                                           AND EF.IDTPENDEFORN(+) = 'P'
                                           AND EC.IDTPENDECLIE(+) = 'P'
                                           AND EL.IDTPENDEFILI(+) = 'P'
                                           AND EP.CDEMPRESA       = MP.CDEMPRESA
                                           AND IE.CDEMPRESA       = MP.CDEMPRESA
                                           AND IE.CDINSCESTA      = MP.CDINSCESTA
                                           AND ET.CDPAIS(+)       = EF.CDPAIS
                                           AND ET.SGESTADO(+)     = EF.SGESTADO
                                           AND ETL.CDPAIS(+)      = EL.CDPAIS
                                           AND ETL.SGESTADO(+)    = EL.SGESTADO
                                           AND ETC.CDPAIS(+)      = EC.CDPAIS
                                           AND NF.IDENTRSAIDOP    = 'S'
                                           AND NVL(NF.IDSISTEMA,'DFS') = 'FIS'
                                           AND NF.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55')
                                           AND ETC.SGESTADO(+)    = EC.SGESTADO
                                         GROUP BY MP.CDEMPRESA, MP.CDINSCESTA, EP.NMRAZSOCEMPR, NF.IDENTRSAIDOP,
                                               IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                               ET.CDPAIS, ETL.CDPAIS, ETC.CDPAIS,
                                               ET.SGESTADO, ETL.SGESTADO, ETC.SGESTADO,
                                               ET.NMESTADO, ETL.NMESTADO, ETC.NMESTADO) A
                                 GROUP BY SGESTADO, IDENTRSAIDOP
                                 UNION ALL
                                SELECT SGESTADO,
                                       IDENTRSAIDOP,
                                       SUM(ROUND(VRCONTABILNF,2))  AS VRCONTABILNF,
                                       SUM(ROUND(VRBASECALCNF,2))  AS VRBASECALCNF,
                                       SUM(ROUND(VRIMPOSTONF,2))   AS VRIMPOSTONF,
                                       SUM(ROUND(VROUTRCRED,2))    AS VROUTRCRED,
                                       SUM(ROUND(VRISENTRIB,2))    AS VRISENTRIB
                                  FROM (SELECT MP.CDEMPRESA, MP.CDINSCESTA, NF.IDENTRSAIDOP,
                                               MIN(MP.DTINIPERIODO) AS DTINIPERIODO,
                                               MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO,
                                               SUM(A.VRCONTABILNF)  AS VRCONTABILNF,
                                               SUM(A.VRBASECALCNF)  AS VRBASECALCNF,
                                               SUM(A.VRIMPOSTONF)   AS VRIMPOSTONF,
                                               SUM(A.VROUTRCRED)    AS VROUTRCRED,
                                               SUM(A.VRISENTRIB)    AS VRISENTRIB,
                                               EP.NMRAZSOCEMPR, IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                               SUBSTR((ET.CDPAIS  ||ETL.CDPAIS  ||ETC.CDPAIS)  ,1,12) AS CDPAIS,
                                               SUBSTR((ET.SGESTADO||ETL.SGESTADO||ETC.SGESTADO),1,6)  AS SGESTADO,
                                               SUBSTR((ET.NMESTADO||ETL.NMESTADO||ETC.NMESTADO),1,90) AS NMESTADO
                                          FROM MAPAAPURAC MP, NOTAFISCAL NF, ENDEFORN EF,
                                               EMPRESA EP, INSCRESTAD IE, ESTADO ET,
                                               ENDECLIE EC, ENDEFILI EL,  ESTADO ETL, ESTADO ETC,
                                               (SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                       SUM(ROUND(VRCONTABILNF,2)) AS VRCONTABILNF,
                                                       SUM(ROUND(VRBASECALCNF,2)) AS VRBASECALCNF,
                                                       SUM(ROUND(VRIMPOSTONF,2))  AS VRIMPOSTONF,
                                                       SUM(ROUND(VROUTRCRED,2))   AS VROUTRCRED,
                                                       SUM(ROUND(VRISENTRIB,2))   AS VRISENTRIB
                                                  FROM (SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                               VRCONTABILNF, VRBASECALCNF, VRIMPOSTONF,
                                                               0 AS VROUTRCRED, 0 AS VRISENTRIB
                                                          FROM IMPOSTONF I, IMPOSTO P
                                                         WHERE CDFISCALNF     = '1'
                                                           AND I.CDIMPOSTO    = P.CDIMPOSTO
                                                           AND P.CDIMPOSTONFE = P_CDIMPOSTO
                                                           AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                         UNION
                                                        SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                               VRCONTABILNF, 0 AS VRBASECALCNF,
                                                               0 AS VRIMPOSTONF, 0 AS VROUTRCRED,
                                                               VRCONTABILNF AS VRISENTRIB
                                                          FROM IMPOSTONF I, IMPOSTO P
                                                         WHERE CDFISCALNF     = '2'
                                                           AND I.CDIMPOSTO    = P.CDIMPOSTO
                                                           AND P.CDIMPOSTONFE = P_CDIMPOSTO
                                                           AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                         UNION
                                                        SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                               VRCONTABILNF, 0 AS VRBASECALCNF,
                                                               0 AS VRIMPOSTONF, VRCONTABILNF AS VROUTRCRED,
                                                               0 AS VRISENTRIB
                                                          FROM IMPOSTONF I, IMPOSTO P
                                                         WHERE CDFISCALNF     = '3'
                                                           AND I.CDIMPOSTO    = P.CDIMPOSTO
                                                           AND P.CDIMPOSTONFE = P_CDIMPOSTO
                                                           AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                         UNION
                                                        SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                               0 AS VRCONTABILNF,
                                                               0 AS VRBASECALCNF, 0 AS VRIMPOSTONF,
                                                               VRIMPOSTONF AS VROUTRCRED,   0 AS VRISENTRIB
                                                          FROM IMPOSTONF I, IMPOSTO P
                                                         WHERE I.CDIMPOSTO   <> P.CDIMPOSTO
                                                           AND P.CDIMPOSTONFE = P_CDIMPOSTO
                                                           AND IDIMPOSTONF    = '4')
                                                 GROUP BY NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF) A
                                         WHERE MP.CDEMPRESA       = P_CDEMPRESA
                                           AND MP.CDINSCESTA      = P_CDINSCESTA
                                           AND MP.CDIMPOSTO       = P_CDIMPOSTO
                                           AND MP.DTINIPERIODO   >= P_DTINICIAL
                                           AND MP.DTFIMPERIODO   <= P_DTFINAL
                                           AND MP.NRSEQUMAPAPU    = A.NRSEQUMAPAPU
                                           AND A.CDFILIAL         = NF.CDFILIAL
                                           AND A.NRLANCTONF       = NF.NRLANCTONF
                                           AND EF.CDFORNECED(+)   = NF.CDFORNECED
                                           AND EC.CDCLIENTE(+)    = NF.CDCLIENTE
                                           AND EL.CDFILIAL(+)     = NF.CDFILIRECE
                                           AND EF.IDTPENDEFORN(+) = 'P'
                                           AND EC.IDTPENDECLIE(+) = 'P'
                                           AND EL.IDTPENDEFILI(+) = 'P'
                                           AND EP.CDEMPRESA       = MP.CDEMPRESA
                                           AND IE.CDEMPRESA       = MP.CDEMPRESA
                                           AND IE.CDINSCESTA      = MP.CDINSCESTA
                                           AND ET.CDPAIS(+)       = EF.CDPAIS
                                           AND ET.SGESTADO(+)     = EF.SGESTADO
                                           AND ETL.CDPAIS(+)      = EL.CDPAIS
                                           AND ETL.SGESTADO(+)    = EL.SGESTADO
                                           AND ETC.CDPAIS(+)      = EC.CDPAIS
                                           AND NF.IDENTRSAIDOP    = 'S'
                                           AND NVL(NF.IDSISTEMA,'DFS')  <> 'FIS'
                                           AND NF.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55')
                                           AND ETC.SGESTADO(+)    = EC.SGESTADO
                                         GROUP BY MP.CDEMPRESA, MP.CDINSCESTA, EP.NMRAZSOCEMPR, NF.IDENTRSAIDOP,
                                               IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                               ET.CDPAIS, ETL.CDPAIS, ETC.CDPAIS,
                                               ET.SGESTADO, ETL.SGESTADO, ETC.SGESTADO,
                                               ET.NMESTADO, ETL.NMESTADO, ETC.NMESTADO) A
                                 GROUP BY SGESTADO, IDENTRSAIDOP
                                 UNION ALL
                                SELECT SGESTADO,
                                       IDENTRSAIDOP,
                                       SUM(ROUND(VRCONTABILNF,2))  AS VRCONTABILNF,
                                       SUM(ROUND(VRBASECALCNF,2))  AS VRBASECALCNF,
                                       SUM(ROUND(VRIMPOSTONF,2))   AS VRIMPOSTONF,
                                       SUM(ROUND(VROUTRCRED,2))    AS VROUTRCRED,
                                       SUM(ROUND(VRISENTRIB,2))    AS VRISENTRIB
                                  FROM (SELECT MP.CDEMPRESA, MP.CDINSCESTA, NF.IDENTRSAIDOP,
                                               MIN(MP.DTINIPERIODO) AS DTINIPERIODO,
                                               MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO,
                                               SUM(A.VRCONTABILNF)  AS VRCONTABILNF,
                                               SUM(A.VRBASECALCNF)  AS VRBASECALCNF,
                                               SUM(A.VRIMPOSTONF)   AS VRIMPOSTONF,
                                               SUM(A.VROUTRCRED)    AS VROUTRCRED,
                                               SUM(A.VRISENTRIB)    AS VRISENTRIB,
                                               EP.NMRAZSOCEMPR, IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                               SUBSTR((ET.CDPAIS  ||ETL.CDPAIS  ||ETC.CDPAIS)  ,1,12) AS CDPAIS,
                                               SUBSTR((ET.SGESTADO||ETL.SGESTADO||ETC.SGESTADO),1,6)  AS SGESTADO,
                                               SUBSTR((ET.NMESTADO||ETL.NMESTADO||ETC.NMESTADO),1,90) AS NMESTADO,
                                               TO_DATE(P_DTINICIAL) AS DTINICIAL,
                                               TO_DATE(P_DTFINAL)   AS DTFINAL
                                          FROM MAPAAPURAC MP, NOTAFISCAL NF, ENDEFORN EF,
                                               EMPRESA EP, INSCRESTAD IE, ESTADO ET,
                                               ENDECLIE EC, ENDEFILI EL,  ESTADO ETL, ESTADO ETC,
                                               (SELECT MP.CDEMPRESA, MP.CDINSCESTA,
                                                       I.NRSEQUMAPAPU, I.CDFILIAL, I.NRLANCTONF, CDFISCOPERNF,
                                                       MIN(MP.DTINIPERIODO) AS DTINIPERIODO,
                                                       MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO,
                                                       SUM(ROUND(VRCONTABILNF,2)) AS VRCONTABILNF,
                                                       SUM(ROUND(DECODE(CDFISCALNF,'1',VRBASECALCNF,0),2)) AS VRBASECALCNF,
                                                       SUM(ROUND(DECODE(CDFISCALNF,'1',VRIMPOSTONF, 0),2)) AS VRIMPOSTONF,
                                                       SUM(ROUND(DECODE(CDFISCALNF,'3',VRCONTABILNF,0),2)) AS VROUTRCRED,
                                                       SUM(ROUND(DECODE(CDFISCALNF,'2',VRCONTABILNF,0),2)) AS VRISENTRIB
                                                  FROM IMPOSTONF I, MAPAAPURAC MP, IMPOSTO P
                                                 WHERE MP.CDEMPRESA       = P_CDEMPRESA
                                                   AND MP.CDINSCESTA      = P_CDINSCESTA
                                                   AND MP.CDIMPOSTO       = P_CDIMPOSTO
                                                   AND MP.DTINIPERIODO   >= P_DTINICIAL
                                                   AND MP.DTFIMPERIODO   <= P_DTFINAL
                                                   AND MP.NRSEQUMAPAPU    = I.NRSEQUMAPAPU
                                                   AND I.CDIMPOSTO BETWEEN P.CDIMPOSTO AND P.CDIMPOSTO
                                                   AND P.CDIMPOSTONFE     = P_CDIMPOSTO
                                                   AND (IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL)
                                                 GROUP BY MP.CDEMPRESA, MP.CDINSCESTA, I.NRSEQUMAPAPU,
                                                       I.CDFILIAL, I.NRLANCTONF, CDFISCOPERNF, MP.DTINIPERIODO, MP.DTFIMPERIODO
                                                 UNION
                                                SELECT MP.CDEMPRESA, MP.CDINSCESTA,
                                                       I.NRSEQUMAPAPU, I.CDFILIAL, I.NRLANCTONF, CDFISCOPERNF,
                                                       MP.DTINIPERIODO,
                                                       MP.DTFIMPERIODO,
                                                       0 AS VRCONTABILNF,
                                                       0 AS VRBASECALCNF, 0 AS VRIMPOSTONF,
                                                       SUM(ROUND(VRIMPOSTONF,2)) AS VROUTRCRED,   0 AS VRISENTRIB
                                                  FROM IMPOSTONF I, MAPAAPURAC MP, IMPOSTO P
                                                 WHERE MP.CDEMPRESA     = P_CDEMPRESA
                                                   AND MP.CDINSCESTA    = P_CDINSCESTA
                                                   AND MP.CDIMPOSTO     = P_CDIMPOSTO
                                                   AND MP.DTINIPERIODO >= P_DTINICIAL
                                                   AND MP.DTFIMPERIODO <= P_DTFINAL
                                                   AND MP.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
                                                   AND I.CDIMPOSTO     <> P.CDIMPOSTO
                                                   AND P.CDIMPOSTONFE   = P_CDIMPOSTO
                                                   AND IDIMPOSTONF      = '4'
                                                 GROUP BY MP.CDEMPRESA, MP.CDINSCESTA, I.NRSEQUMAPAPU,
                                                       I.CDFILIAL, I.NRLANCTONF, CDFISCOPERNF, MP.DTINIPERIODO, MP.DTFIMPERIODO) A
                                         WHERE MP.CDEMPRESA       = P_CDEMPRESA
                                           AND MP.CDINSCESTA      = P_CDINSCESTA
                                           AND MP.CDIMPOSTO       = P_CDIMPOSTO
                                           AND MP.DTINIPERIODO   >= P_DTINICIAL
                                           AND MP.DTFIMPERIODO   <= P_DTFINAL
                                           AND MP.NRSEQUMAPAPU    = A.NRSEQUMAPAPU
                                           AND A.CDFILIAL         = NF.CDFILIAL
                                           AND A.NRLANCTONF       = NF.NRLANCTONF
                                           AND EF.CDFORNECED(+)   = NF.CDFORNECED
                                           AND EC.CDCLIENTE(+)    = NF.CDCLIENTE
                                           AND EL.CDFILIAL(+)     = NF.CDFILIEMIT
                                           AND EF.IDTPENDEFORN(+) = 'P'
                                           AND EC.IDTPENDECLIE(+) = 'P'
                                           AND EL.IDTPENDEFILI(+) = 'P'
                                           AND EP.CDEMPRESA       = MP.CDEMPRESA
                                           AND IE.CDEMPRESA       = MP.CDEMPRESA
                                           AND IE.CDINSCESTA      = MP.CDINSCESTA
                                           AND ET.CDPAIS(+)       = EF.CDPAIS
                                           AND ET.SGESTADO(+)     = EF.SGESTADO
                                           AND ETL.CDPAIS(+)      = EL.CDPAIS
                                           AND ETL.SGESTADO(+)    = EL.SGESTADO
                                           AND ETC.CDPAIS(+)      = EC.CDPAIS
                                           AND NF.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55')
                                           AND NF.IDENTRSAIDOP    = 'E'
                                           AND ETC.SGESTADO(+)    = EC.SGESTADO
                                         GROUP BY MP.CDEMPRESA, MP.CDINSCESTA, EP.NMRAZSOCEMPR, NF.IDENTRSAIDOP,
                                               IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                               ET.CDPAIS, ETL.CDPAIS, ETC.CDPAIS,
                                               ET.SGESTADO, ETL.SGESTADO, ETC.SGESTADO,
                                               ET.NMESTADO, ETL.NMESTADO, ETC.NMESTADO) A
                                 GROUP BY SGESTADO, IDENTRSAIDOP
                                 ORDER BY SGESTADO) NF
                         GROUP BY DECODE(NF.IDENTRSAIDOP, 'E', '0', '1'), SUBSTR(NF.SGESTADO,1,2) ) LOOP
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('38'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE320.ARQ_E320, P_NRSEQARQMAG);
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
      END LOOP;

      FOR C_REGE330 IN (SELECT ('|E330'                                                                                       || '|' ||
                               '1'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRCONTABILNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRBASECALCNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSTONF, 2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSUB,   2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               '0'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VRISENTRIB,    2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VROUTRCRED,    2)), '999999999990.00')), '.', ','),'0,00') || '|'  ) AS ARQ_E330
                          FROM (SELECT SUM(ROUND(T.VRCONTITIMP,2)) AS VRCONTABILNF,
                                       SUM(DECODE(T.CDFISCALIT,'1',ROUND(T.VRBASECALCIT,2),0)) AS VRBASECALCNF,
                                       SUM(DECODE(T.CDFISCALIT,'1',ROUND(T.VRIMPOSTOIT, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(T.CDFISCALIT,'3',ROUND(T.VRCONTITIMP, 2),0)) AS VROUTRCRED,
                                       SUM(DECODE(T.CDFISCALIT,'2',ROUND(T.VRCONTITIMP, 2),0)) AS VRISENTRIB,
                                       SUM(ROUND(VALOR_IMPOSTO_ITEM_NFE(T.CDFILIAL, T.NRLANCTONF, T.NRSEQITPROD, '80', 'I','1'),2)) AS VRIMPOSUB
                                  FROM NOTAFISCAL N, ITEMPROIMPOS T, IMPOSTO P,
                                       (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
                                          FROM MAPAAPURAC M, IMPOSTONF I
                                         WHERE M.CDEMPRESA    = P_CDEMPRESA
                                           AND M.CDINSCESTA   = P_CDINSCESTA
                                           AND M.DTINIPERIODO = C_REGE300.DTINICIAL
                                           AND M.DTFIMPERIODO = C_REGE300.DTFINAL
                                           AND M.CDIMPOSTO    = P_CDIMPOSTO
                                           AND I.NRSEQUMAPAPU = M.NRSEQUMAPAPU) I
                                 WHERE I.CDFILIAL        = T.CDFILIAL
                                   AND I.NRLANCTONF      = T.NRLANCTONF
                                   AND T.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND SUBSTR(T.CDFISCOPERIT,1,1) = '1'
                                   AND NVL(T.NRITPROIMPOS, '1') <> '3'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                   AND N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55')
                                   AND N.IDENTRSAIDOP     = 'E')N
                         UNION ALL
                        SELECT ('|E330'                                                                                       || '|' ||
                               '2'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRCONTABILNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRBASECALCNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSTONF, 2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSUB,   2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               '0'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VRISENTRIB,    2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VROUTRCRED,    2)), '999999999990.00')), '.', ','),'0,00') || '|'  ) AS ARQ_E330
                          FROM (SELECT SUM(ROUND(T.VRCONTITIMP,2)) AS VRCONTABILNF, 
                                       SUM(DECODE(T.CDFISCALIT,'1',ROUND(T.VRBASECALCIT,2),0)) AS VRBASECALCNF, 
                                       SUM(DECODE(T.CDFISCALIT,'1',ROUND(T.VRIMPOSTOIT, 2),0)) AS VRIMPOSTONF, 
                                       SUM(DECODE(T.CDFISCALIT,'3',ROUND(T.VRCONTITIMP, 2),0)) AS VROUTRCRED, 
                                       SUM(DECODE(T.CDFISCALIT,'2',ROUND(T.VRCONTITIMP, 2),0)) AS VRISENTRIB, 
                                       SUM(ROUND(VALOR_IMPOSTO_ITEM_NFE(T.CDFILIAL, T.NRLANCTONF, T.NRSEQITPROD, '80', 'I','1'),2)) AS VRIMPOSUB 
                                  FROM NOTAFISCAL N, ITEMPROIMPOS T, IMPOSTO P,
                                       (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF 
									      FROM MAPAAPURAC M, IMPOSTONF I
										 WHERE M.CDEMPRESA       = P_CDEMPRESA 
                                           AND M.CDINSCESTA      = P_CDINSCESTA 
                                           AND M.DTINIPERIODO    = C_REGE300.DTINICIAL 
                                           AND M.DTFIMPERIODO    = C_REGE300.DTFINAL 
                                           AND M.CDIMPOSTO       = P_CDIMPOSTO 
                                           AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU) I     								  
                                 WHERE I.CDFILIAL        = T.CDFILIAL
                                   AND I.NRLANCTONF      = T.NRLANCTONF
                                   AND T.CDIMPOSTO       = P.CDIMPOSTO 
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO 
                                   AND SUBSTR(T.CDFISCOPERIT,1,1) = '2' 
                                   AND NVL(T.NRITPROIMPOS, '1') <> '3' 
                                   AND N.CDFILIAL        = I.CDFILIAL 
                                   AND N.NRLANCTONF      = I.NRLANCTONF 
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) 
                                   AND N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55') 
                                   AND N.IDENTRSAIDOP     = 'E') N
                         UNION ALL
                        SELECT ('|E330'                                                                                       || '|' ||
                               '3'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRCONTABILNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRBASECALCNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSTONF, 2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSUB,   2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               '0'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VRISENTRIB,    2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VROUTRCRED,    2)), '999999999990.00')), '.', ','),'0,00') || '|'  ) AS ARQ_E330
                          FROM (SELECT SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                       SUM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2)) AS VRIMPOSUB
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND SUBSTR(I.CDFISCOPERNF,1,1) = '3'
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                   AND N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55')
                                   AND N.IDENTRSAIDOP    = 'E')N
                         UNION ALL
                        SELECT ('|E330'                                                                                       || '|' ||
                               '4'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRCONTABILNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRBASECALCNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSTONF, 2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSUB,   2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               '0'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VRISENTRIB,    2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VROUTRCRED,    2)), '999999999990.00')), '.', ','),'0,00') || '|'  ) AS ARQ_E330
                          FROM (SELECT SUM(ROUND(T.VRCONTITIMP,2)) AS VRCONTABILNF,
                                       SUM(DECODE(T.CDFISCALIT,'1',ROUND(T.VRBASECALCIT,2),0)) AS VRBASECALCNF,
                                       SUM(DECODE(T.CDFISCALIT,'1',ROUND(T.VRIMPOSTOIT, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(T.CDFISCALIT,'3',ROUND(T.VRCONTITIMP,2),0)) AS VROUTRCRED,
                                       SUM(DECODE(T.CDFISCALIT,'2',ROUND(T.VRCONTITIMP,2),0)) AS VRISENTRIB,
                                       SUM(ROUND(VALOR_IMPOSTO_ITEM_NFE(T.CDFILIAL, T.NRLANCTONF, T.NRSEQITPROD, '80', 'I','1'),2)) AS VRIMPOSUB
                                  FROM NOTAFISCAL N, ITEMPROIMPOS T, IMPOSTO P,
                                       (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
                                          FROM MAPAAPURAC M, IMPOSTONF I
                                         WHERE M.CDEMPRESA    = P_CDEMPRESA
                                           AND M.CDINSCESTA   = P_CDINSCESTA
                                           AND M.DTINIPERIODO = C_REGE300.DTINICIAL
                                           AND M.DTFIMPERIODO = C_REGE300.DTFINAL
                                           AND M.CDIMPOSTO    = P_CDIMPOSTO
                                           AND I.NRSEQUMAPAPU = M.NRSEQUMAPAPU) I
                                 WHERE I.CDFILIAL        = T.CDFILIAL
                                   AND I.NRLANCTONF      = T.NRLANCTONF
                                   AND T.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND NVL(T.NRITPROIMPOS, '1') <> '3'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                   AND N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55')
                                   AND N.IDENTRSAIDOP    = 'E') N
                         UNION ALL
                        SELECT ('|E330'                                                                                       || '|' ||
                               '5'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRCONTABILNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRBASECALCNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSTONF, 2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSUB,   2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               '0'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VRISENTRIB,    2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(DECODE(TP_NF,'N',VROUTRCRED,0),2)), '999999999990.00')), '.', ','),'0,00') || '|'  ) AS ARQ_E330
                          FROM (SELECT SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                       SUM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2)) AS VRIMPOSUB,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRTOTIMPOSNF,
                                       0 AS VRTOTENTR,
                                       0 AS VRTOTOUTRCRED,
                                       'N' AS TP_NF
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND SUBSTR(I.CDFISCOPERNF,1,1) = '5'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND NVL(N.IDSISTEMA,'DFS') <> 'FIS'
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55')
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                 UNION ALL
                                SELECT ROUND(I.VRCONTABILNF,2) AS VRCONTABILNF,
                                       DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0) AS VRBASECALCNF,
                                       DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0) AS VRIMPOSTONF,
                                       DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0) AS VROUTRCRED,
                                       DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0) AS VRISENTRIB,
                                       ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2) AS VRIMPOSUB,
                                       DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0) AS VRTOTIMPOSNF,
                                       0 AS VRTOTENTR,
                                       0 AS VRTOTOUTRCRED,
                                       NVL((SELECT MAX('E')
                                             FROM MOVCAIXA M, VENDA V
                                            WHERE M.CDFILIAL   = V.CDFILIAL
                                              AND M.CDCAIXA    = V.CDCAIXA
                                              AND M.NRSEQVENDA = V.NRSEQVENDA
                                              AND NVL(V.IDTPEMISVEND,'E') = 'E'
                                              AND M.CDFILIALNFFIS = N.CDFILIAL
                                              AND M.NRLANCTONFFIS = N.NRLANCTONF
                                              AND M.CDFILIAL      = N.CDFILIEMIT),'N') AS TP_NF
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND SUBSTR(I.CDFISCOPERNF,1,1) = '5'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND NVL(N.IDSISTEMA,'DFS') = 'FIS'
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')))N
                         UNION ALL
                        SELECT ('|E330'                                                                                       || '|' ||
                               '6'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRCONTABILNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRBASECALCNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSTONF, 2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSUB,   2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               '0'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VRISENTRIB,    2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VROUTRCRED,    2)), '999999999990.00')), '.', ','),'0,00') || '|'  ) AS ARQ_E330
                          FROM (SELECT SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                       ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2) AS VRIMPOSUB,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRTOTIMPOSNF,
                                       0 AS VRTOTENTR,
                                       0 AS VRTOTOUTRCRED
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND SUBSTR(I.CDFISCOPERNF,1,1) = '6'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND NVL(N.IDSISTEMA,'DFS') <> 'FIS'
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55')
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                 GROUP BY ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2)
                                 UNION ALL
                                SELECT SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                       SUM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2)) AS VRIMPOSUB,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRTOTIMPOSNF,
                                       0 AS VRTOTENTR,
                                       0 AS VRTOTOUTRCRED
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND SUBSTR(I.CDFISCOPERNF,1,1) = '6'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND NVL(N.IDSISTEMA,'DFS') = 'FIS'
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')))N
                         UNION ALL
                        SELECT ('|E330'                                                                                       || '|' ||
                               '7'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRCONTABILNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRBASECALCNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSTONF, 2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSUB,   2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               '0'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VRISENTRIB,    2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VROUTRCRED,    2)), '999999999990.00')), '.', ','),'0,00') || '|'  ) AS ARQ_E330
                          FROM (SELECT SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                       SUM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I', '1'),2)) AS VRIMPOSUB,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRTOTIMPOSNF,
                                       0 AS VRTOTENTR,
                                       0 AS VRTOTOUTRCRED
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND SUBSTR(I.CDFISCOPERNF,1,1) = '7'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND NVL(N.IDSISTEMA,'DFS') <> 'FIS'
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55')
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                 UNION ALL
                                SELECT SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                       SUM(ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2)) AS VRIMPOSUB,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRTOTIMPOSNF,
                                       0 AS VRTOTENTR,
                                       0 AS VRTOTOUTRCRED
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND SUBSTR(I.CDFISCOPERNF,1,1) = '7'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND NVL(N.IDSISTEMA,'DFS') = 'FIS'
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')))N
                         UNION ALL
                        SELECT ('|E330'                                                                                       || '|' ||
                               '8'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRCONTABILNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRBASECALCNF,2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSTONF, 2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(N.VRIMPOSUB,   2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               '0'                                                                                            || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(VRISENTRIB,    2)), '999999999990.00')), '.', ','),'0,00') || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(SUM(ROUND(DECODE(TP_NF,'N',VROUTRCRED,0),2)), '999999999990.00')), '.', ','),'0,00') || '|'  ) AS ARQ_E330
                          FROM (SELECT SUM(ROUND(I.VRCONTABILNF,2)) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0)) AS VRBASECALCNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0)) AS VRIMPOSTONF,
                                       SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)) AS VROUTRCRED,
                                       SUM(DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0)) AS VRISENTRIB,
                                       ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2) AS VRIMPOSUB,
                                       0 AS VRTOTIMPOSNF,
                                       0 AS VRTOTENTR,
                                       SUM(DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0))  AS VRTOTOUTRCRED,
                                       'N' AS TP_NF
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND NVL(N.IDSISTEMA,'DFS') <> 'FIS'
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28','55')
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                 GROUP BY ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2)
                                 UNION ALL
                                SELECT ROUND(I.VRCONTABILNF,2) AS VRCONTABILNF,
                                       DECODE(I.CDFISCALNF,'1',ROUND(I.VRBASECALCNF,2),0) AS VRBASECALCNF,
                                       DECODE(I.CDFISCALNF,'1',ROUND(I.VRIMPOSTONF, 2),0) AS VRIMPOSTONF,
                                       DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0) AS VROUTRCRED,
                                       DECODE(I.CDFISCALNF,'2',ROUND(I.VRCONTABILNF,2),0) AS VRISENTRIB,
                                       ROUND(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1'),2) AS VRIMPOSUB,
                                       0 AS VRTOTIMPOSNF,
                                       0 AS VRTOTENTR,
                                       DECODE(I.CDFISCALNF,'3',ROUND(I.VRCONTABILNF,2),0)  AS VRTOTOUTRCRED,
                                       NVL((SELECT MAX('E')
                                             FROM MOVCAIXA M, VENDA V
                                            WHERE M.CDFILIAL   = V.CDFILIAL
                                              AND M.CDCAIXA    = V.CDCAIXA
                                              AND M.NRSEQVENDA = V.NRSEQVENDA
                                              AND NVL(V.IDTPEMISVEND,'E') = 'E'
                                              AND M.CDFILIALNFFIS = N.CDFILIAL
                                              AND M.NRLANCTONFFIS = N.NRLANCTONF
                                              AND M.CDFILIAL      = N.CDFILIEMIT),'N') AS TP_NF
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = P.CDIMPOSTO
                                   AND P.CDIMPOSTONFE    = P_CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND NVL(N.IDSISTEMA,'DFS') = 'FIS'
                                   AND N.IDENTRSAIDOP    = 'S'
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')))N ) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('39'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE330.ARQ_E330, P_NRSEQARQMAG);
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
      END LOOP;

      FOR C_REGE340 IN (SELECT ('|E340'           || '|' ||
                               IR.CDAJUSTEITMAPA || '|' ||
                               NVL(REPLACE(LTRIM(TO_CHAR(ROUND(IR.VRITEMMAPR,2),'999999999990.00')), '.', ','),'0,00')   || '|' ||
                               ''   || '|' ||
                               ''   || '|' ||
                               '0'  || '|' ||
                               ''   || '|' ||
                               SUBSTR(IDTIPOITMAPR,3) || '|') AS ARQ_E340, IDTIPOITMAPR
                          FROM (SELECT ROUND(SUM(IR.VRITEMMAPR),2) AS VRITEMMAPR,
                                       DECODE(IR.IDTIPOITMAPR,'DA','100',IR.CDAJUSTEITMAPA) AS CDAJUSTEITMAPA,
                                       DECODE(IR.IDTIPOITMAPR,'DA','DA'||'AAAAAFCP','OC','OC'||'OC','OD','OD'||'OD','ED','ED'||'ED','EC','EC'||'EC','DE','DE'||'DE') AS IDTIPOITMAPR
                                  FROM MAPAAPURAC M, ITMAPARECUP IR
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = P_DTINICIAL
                                   AND M.DTFIMPERIODO    = P_DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND IR.IDTIPOITMAPR <> 'DA'
                                   AND M.NRSEQUMAPAPU    = IR.NRSEQUMAPAPU
                                 GROUP BY DECODE(IR.IDTIPOITMAPR,'DA','100',IR.CDAJUSTEITMAPA),
                                          DECODE(IR.IDTIPOITMAPR,'DA','DA'||'AAAAAFCP','OC','OC'||'OC','OD','OD'||'OD','ED','ED'||'ED','EC','EC'||'EC','DE','DE'||'DE')) IR
                                 ORDER BY ARQ_E340) LOOP

         SELECT MAX(SUBSTR(DSREGARQMAG,1,14))
           INTO V_TEMFCP
           FROM ARQMAGNETICO
          WHERE SUBSTR(DSREGARQMAG,1,14) = '|0450|AAAAAFCP'
            AND NRSEQARQMAG = P_NRSEQARQMAG;

         BEGIN
            SELECT MAX('S')
              INTO V_INFCOMPL
              FROM ARQMAGNETICO
             WHERE SUBSTR(DSREGARQMAG,1,14) LIKE '|0450|'||SUBSTR(C_REGE340.IDTIPOITMAPR,3)||'%'
               AND NRSEQARQMAG = P_NRSEQARQMAG;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_INFCOMPL := '';
         END;

         IF ((V_TEMFCP IS NULL) AND (SUBSTR(C_REGE340.IDTIPOITMAPR,1,2) = 'DA')) THEN
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('0900000000', '|0450|AAAAAFCP|OPERAES SUJEITAS AO ADICIONAL DE 2% DO FUNDO DE COMBATE  PROBREZA|', P_NRSEQARQMAG);
         ELSIF ((V_INFCOMPL IS NULL) AND (SUBSTR(C_REGE340.IDTIPOITMAPR,1,2) = 'OC')) THEN
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('0900000000', '|0450|'||SUBSTR(C_REGE340.IDTIPOITMAPR,3)||'|'|| 'OUTROS CRDITOS' ||'|', P_NRSEQARQMAG);
         ELSIF ((V_INFCOMPL IS NULL) AND (SUBSTR(C_REGE340.IDTIPOITMAPR,1,2) = 'OD')) THEN
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('0900000000', '|0450|'||SUBSTR(C_REGE340.IDTIPOITMAPR,3)||'|'|| 'OUTROS DBITOS' ||'|', P_NRSEQARQMAG);
         ELSIF ((V_INFCOMPL IS NULL) AND (SUBSTR(C_REGE340.IDTIPOITMAPR,1,2) = 'ED')) THEN
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('0900000000', '|0450|'||SUBSTR(C_REGE340.IDTIPOITMAPR,3)||'|'|| 'ESTORNO DE DBITOS' ||'|', P_NRSEQARQMAG);
         ELSIF ((V_INFCOMPL IS NULL) AND (SUBSTR(C_REGE340.IDTIPOITMAPR,1,2) = 'EC')) THEN
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('0900000000', '|0450|'||SUBSTR(C_REGE340.IDTIPOITMAPR,3)||'|'|| 'ESTORNO DE CRDITOS' ||'|', P_NRSEQARQMAG);
         ELSIF ((V_INFCOMPL IS NULL) AND (SUBSTR(C_REGE340.IDTIPOITMAPR,1,2) = 'DE')) THEN
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('0900000000', '|0450|'||SUBSTR(C_REGE340.IDTIPOITMAPR,3)||'|'|| 'DBITO ESPECIAL' ||'|', P_NRSEQARQMAG);
         END IF;

         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('40'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE340.ARQ_E340, P_NRSEQARQMAG);

         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
      END LOOP;

      FOR C_REGE350 IN (SELECT ('|E350'        || '|' ||
                               DADOS.COD_OR    || '|' ||
                               DADOS.VL_OR     || '|' ||
                               DADOS.DT_VCTO   || '|' ||
                               DADOS.COD_REC   || '|' ||
                               ''              || '|' ||
                               ''              || '|' ||
                               '0'             || '|' ||
                               ''              || '|' ||
                               DADOS.COD_FCP   || '|'  ) AS ARQ_E350
                          FROM (SELECT '000' AS COD_OR,
                                       NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTAGUIA,2), '999999999990.00')), '.', ','),'0,00') AS VL_OR,
                                       TO_CHAR(DTVENCGUIA,'DDMMYYYY') AS DT_VCTO,
                                       CDRECEGUIA AS COD_REC,
                                       '' AS COD_FCP
                                  FROM MAPAAPURAC M, INSCRESTAD I
                                 WHERE M.CDEMPRESA     = P_CDEMPRESA
                                   AND M.CDINSCESTA    = P_CDINSCESTA
                                   AND M.DTINIPERIODO  = P_DTINICIAL
                                   AND M.DTFIMPERIODO  = P_DTFINAL
                                   AND M.CDIMPOSTO     = P_CDIMPOSTO
                                   AND M.CDEMPRESA     = I.CDEMPRESA
                                   AND M.CDINSCESTA    = I.CDINSCESTA
                                   AND M.DTVENCGUIA IS NOT NULL
                                   AND M.VRTOTAGUIA > 0
                                 UNION
                                SELECT CDOBRIGAGUIA AS COD_OR,
                                       NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRRECEITAGUIA,2), '999999999990.00')), '.', ','),'0,00') AS VL_OR,
                                       TO_CHAR(DTVENCGUIACOMPL,'DDMMYYYY') AS DT_VCTO,
                                       CDRECEITAGUIA AS COD_REC,
                                       '' AS COD_FCP
                                  FROM MAPAAPURAC M, GUIACOMPLMAPA G
                                 WHERE M.CDEMPRESA     = P_CDEMPRESA
                                   AND M.CDINSCESTA    = P_CDINSCESTA
                                   AND M.DTINIPERIODO  = P_DTINICIAL
                                   AND M.DTFIMPERIODO  = P_DTFINAL
                                   AND M.CDIMPOSTO     = P_CDIMPOSTO
                                   AND M.NRSEQUMAPAPU  = G.NRSEQUMAPAPU
                                   AND G.DTVENCGUIACOMPL IS NOT NULL
                                   AND G.VRRECEITAGUIA > 0) DADOS) LOOP

         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('41'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE350.ARQ_E350, P_NRSEQARQMAG);
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
      END LOOP;

      SELECT SUM(VRRECEITAGUIA)
        INTO V_VRRECEITAGUIA
        FROM GUIACOMPLMAPA G, MAPAAPURAC M, MAPARECUP R
       WHERE G.NRSEQUMAPAPU = M.NRSEQUMAPAPU
         AND M.CDEMPRESA    = P_CDEMPRESA
         AND M.CDINSCESTA   = P_CDINSCESTA
         AND M.DTINIPERIODO = P_DTINICIAL
         AND M.DTFIMPERIODO = P_DTFINAL
         AND M.CDIMPOSTO    = P_CDIMPOSTO
         AND M.NRSEQUMAPAPU = R.NRSEQUMAPAPU
         AND R.VRDIFALIQU   = 0;

      FOR C_REGE360 IN (SELECT ('|E360'         || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VRNORMDEBI),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VROUTRDEBI),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VRESTOCRED),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VRTOTDEB),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VRNORMCRED),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VROUTRCRED),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VRESTODEBI),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VRSUBTOTCRED),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VRSLDCRANTE),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VRTOTCRED),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(DECODE((N.VRTOTCRED-N.VRTOTDEB),ABS(N.VRTOTCRED-N.VRTOTDEB),(N.VRTOTCRED-N.VRTOTDEB),0)),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(DECODE((N.VRTOTDEB-N.VRTOTCRED),ABS(N.VRTOTDEB-N.VRTOTCRED),(N.VRTOTDEB-N.VRTOTCRED),0)),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VRDEDUCAO),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(DECODE(N.VRICMSRECOLHE,ABS(N.VRICMSRECOLHE),N.VRICMSRECOLHE,0)),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(P_VALORSTENTR),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(0),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(0),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               '0,00'             || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VRDIFALIQU),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS(N.VRTOTAIMPOS),2),0), '999999999990.00')), '.', ',')    || '|' ||
                               '0,00'             || '|'  ) AS ARQ_E360
                          FROM (SELECT ROUND(R.VRNORMDEBI,2) AS VRNORMDEBI,
                                       ROUND(R.VROUTRDEBI,2) AS VROUTRDEBI,
                                       ROUND(R.VRESTOCRED,2) AS VRESTOCRED,
                                       ROUND(R.VRNORMDEBI+R.VROUTRDEBI+R.VRESTOCRED,2) AS VRTOTDEB,
                                       ROUND(R.VRNORMCRED,2) AS VRNORMCRED,
                                       ROUND(R.VROUTRCRED,2) AS VROUTRCRED,
                                       ROUND(R.VRESTODEBI,2) AS VRESTODEBI,
                                       ROUND(R.VRNORMCRED+R.VROUTRCRED+R.VRESTODEBI,2) AS VRSUBTOTCRED,
                                       ROUND(R.VRSLDCRANTE,2) AS VRSLDCRANTE,
                                       ROUND(R.VRNORMCRED+R.VROUTRCRED+R.VRESTODEBI+VRSLDCRANTE,2) AS VRTOTCRED,
                                       ROUND(R.VRDEDUCAO,2) AS VRDEDUCAO,
                                       ROUND((R.VRNORMDEBI+R.VROUTRDEBI+R.VRESTOCRED)-(R.VRNORMCRED+R.VROUTRCRED+R.VRESTODEBI+VRSLDCRANTE)-R.VRDEDUCAO,2) AS VRICMSRECOLHE,
                                       ROUND(R.VRDIFALIQU,2) AS VRDIFALIQU,
                                       ROUND(M.VRTOTAIMPOS,2) AS VRTOTAIMPOS
                                  FROM MAPAAPURAC M, MAPARECUP R
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE300.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE300.DTFINAL
                                   AND M.CDIMPOSTO       = P_CDIMPOSTO
                                   AND R.NRSEQUMAPAPU    = M.NRSEQUMAPAPU) N) LOOP
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('42'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE360.ARQ_E360, P_NRSEQARQMAG);
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
      END LOOP;
   END LOOP;

   FOR C_REGE500 IN (SELECT ('|E500'                             || '|' ||
                             TO_CHAR(DTINIPERIODO,'DDMMYYYY')    || '|' ||
                             TO_CHAR(DTFIMPERIODO,'DDMMYYYY')    || '|'  ) AS ARQ_E500,
                             TO_CHAR(DTINIPERIODO,'DDMMYYYY') AS DTINICIAL,
                             TO_CHAR(DTFIMPERIODO,'DDMMYYYY') AS DTFINAL
                        FROM MAPAAPURAC
                       WHERE CDEMPRESA     = P_CDEMPRESA
                         AND CDINSCESTA    = P_CDINSCESTA
                         AND DTINIPERIODO  = P_DTINICIAL
                         AND DTFIMPERIODO  = P_DTFINAL
                         AND CDIMPOSTO     = '10') LOOP
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('43'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE500.ARQ_E500, P_NRSEQARQMAG);
      V_CONTREGE := NVL(V_CONTREGE,0) + 1;

      FOR C_REGE510 IN (SELECT ('|E510'                                                                                || '|' ||
                               N.CDFISCOPERNF                                                                          || '|' ||
                               N.IMPOS                                                                                 || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(N.VRCONTABILNF,2),0), '999999999990.00')), '.', ',')    || '|' ||
                               REPLACE(LTRIM(TO_CHAR(NVL(ROUND(N.VRBASECALCNF,2),0), '999999999990.00')), '.', ',')    || '|' ||
                               N.IMPOSTRIB                                                                             || '|'  ) AS ARQ_E510
                          FROM (SELECT DECODE(I.CDFISCALNF, '1', DECODE(I.VRALIQNF, 0, '02', '00'), '2', '03', '3', '04') AS IMPOS,
                                       I.CDFISCOPERNF, I.CDIMPOSTO,
                                       SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                       SUM(DECODE(I.CDFISCALNF,'1',I.VRBASECALCNF,0)) AS VRBASECALCNF,
                                       MAX(VALOR_IMPOSTO_NFE(N.CDFILIAL, N.NRLANCTONF, '80', 'I','1')) AS IMPOSTRIB
                                  FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO IM
                                 WHERE M.CDEMPRESA       = P_CDEMPRESA
                                   AND M.CDINSCESTA      = P_CDINSCESTA
                                   AND M.DTINIPERIODO    = C_REGE500.DTINICIAL
                                   AND M.DTFIMPERIODO    = C_REGE500.DTFINAL
                                   AND M.CDIMPOSTO       = '10'
                                   AND I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU
                                   AND I.CDIMPOSTO       = IM.CDIMPOSTO
                                   AND IM.CDIMPOSTONFE   = M.CDIMPOSTO
                                   AND NVL(I.IDIMPOSTONF, '1') <> '3'
                                   AND N.CDFILIAL        = I.CDFILIAL
                                   AND NVL(N.IDSISTEMA,'DFS') <> 'FIS'
                                   AND N.NRLANCTONF      = I.NRLANCTONF
                                   AND ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                 GROUP BY DECODE(I.CDFISCALNF, '1', DECODE(I.VRALIQNF, 0, '02', '00'), '2', '03', '3', '04'),
                                       I.CDFISCOPERNF, I.CDSITUTRIBNF, I.CDIMPOSTO )N
                         GROUP BY N.CDFISCOPERNF, N.IMPOS, N.VRCONTABILNF, N.VRBASECALCNF, N.IMPOSTRIB ) LOOP
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('44'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE510.ARQ_E510, P_NRSEQARQMAG);
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
      END LOOP;

      FOR C_REGE530 IN (SELECT ('|E530'                                                                                            || '|' ||
                                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(R.VRSLDCRANTE,2),0), '999999999990.00')), '.', ',')                || '|' ||
                                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(R.VRTOTADEBI,2),0), '999999999990.00')), '.', ',')                 || '|' ||
                                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(R.VRTOTACRED,2),0), '999999999990.00')), '.', ',')                 || '|' ||
                                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(R.VROUTRDEBI + VRESTOCRED,2),0), '999999999990.00')), '.', ',')    || '|' ||
                                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(R.VROUTRCRED + R.VRESTODEBI,2),0), '999999999990.00')), '.', ',')  || '|' ||
                                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(R.VRSALDOCRED,2),0), '999999999990.00')), '.', ',')                || '|' ||
                                REPLACE(LTRIM(TO_CHAR(NVL(ROUND(R.VRSALDODEBI,2),0), '999999999990.00')), '.', ',')                || '|'  ) AS ARQ_E530
                           FROM MAPAAPURAC M, MAPARECUP R
                          WHERE M.CDEMPRESA       = P_CDEMPRESA
                            AND M.CDINSCESTA      = P_CDINSCESTA
                            AND M.DTINIPERIODO    = C_REGE500.DTINICIAL
                            AND M.DTFIMPERIODO    = C_REGE500.DTFINAL
                            AND M.CDIMPOSTO       = '10'
                            AND R.NRSEQUMAPAPU    = M.NRSEQUMAPAPU) LOOP
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('45'||LPAD(RTRIM(V_CONTREGE), 8, '0'), C_REGE530.ARQ_E530, P_NRSEQARQMAG);
         V_CONTREGE := NVL(V_CONTREGE,0) + 1;
      END LOOP;
   END LOOP;

   IF V_CONTREGE <> 0 THEN
      V_MOVIMENT := 0;
   ELSE
      V_MOVIMENT := 1;
   END IF;

   V_CONTREGE := NVL(V_CONTREGE,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('29'||LPAD(RTRIM(V_CONTREGE), 8, '0'), '|E001'|| '|' ||V_MOVIMENT|| '|', P_NRSEQARQMAG);

   V_CONTREGE := NVL(V_CONTREGE,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('46'||LPAD(RTRIM(V_CONTREGE), 8, '0'), '|E990'|| '|' ||V_CONTREGE|| '|', P_NRSEQARQMAG);

   RETURN(V_CONTREGE);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQDIGITAL_BLOCOE','5.85.000'); END;
/
